﻿/*
ssc (static site checker)
Copyright (c) 2020,2021 Dylan Harris
https://dylanharris.org/

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public Licence as published by
the Free Software Foundation, either version 3 of the Licence,  or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public Licence for more details.

You should have received a copy of the GNU General Public
Licence along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
*/

#include "main/standard.h"
#include "parser/text-data.h"

wotsit_t wotsit_table [] =
{   { { HTML_1_0 }, { HTML_UNDEF }, "AElig" },
    { { HTML_1_0 }, { HTML_UNDEF }, "Aacute" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Abreve" },
    { { HTML_1_0 }, { HTML_UNDEF }, "Acirc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Acy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Afr" },
    { { HTML_PLUS }, { HTML_PLUS }, "Agr" },
    { { HTML_1_0 }, { HTML_UNDEF }, "Agrave" },
    { { HTML_4_0 }, { HTML_UNDEF }, "Alpha" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Amacr" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "And" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Aogon" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Aopf" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "ApplyFunction" },
    { { HTML_1_0 }, { HTML_UNDEF }, "Aring" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Ascr" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "Assign" },
    { { HTML_1_0 }, { HTML_UNDEF }, "Atilde" },
    { { HTML_1_0 }, { HTML_UNDEF }, "Auml" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "Backslash" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "BadBreak" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Barv" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Barwed" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Bcy" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "Because" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Bernoullis" },
    { { HTML_4_0 }, { HTML_UNDEF }, "Beta" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Bfr" },
    { { HTML_PLUS }, { HTML_PLUS }, "Bgr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Bopf" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "Breve" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Bscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Bumpeq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "CHcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "COPY" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Cacute" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "Cap" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "CapitalDifferentialD" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Cayleys" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Ccaron" },
    { { HTML_1_0 }, { HTML_UNDEF }, "Ccedil" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Ccirc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Cconint" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Cdot" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "Cedilla" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "CenterDot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Cfr" },
    { { HTML_4_0 }, { HTML_UNDEF }, "Chi" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "CircleDot" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "CircleMinus" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "CirclePlus" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "CircleTimes" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "ClockwiseContourIntegral" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "CloseCurlyDoubleQuote" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "CloseCurlyQuote" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "Colon" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Colone" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "Congruent" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Conint" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "ContourIntegral" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Copf" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "Coproduct" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "CounterClockwiseContourIntegral" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "Cross" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Cscr" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "Cup" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "CupCap" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "DD" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "DDotrahd" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "DJcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "DScy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "DZcy" },
    { { HTML_4_0 }, { HTML_UNDEF }, "Dagger" },
    { { HTML_PLUS }, { HTML_UNDEF }, "Darr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Dashv" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Dcaron" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Dcy" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "Del" },
    { { HTML_PLUS }, { HTML_UNDEF }, "Delta" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Dfr" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "DiacriticalAcute" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "DiacriticalDot" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "DiacriticalDoubleAcute" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "DiacriticalGrave" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "DiacriticalLeftArrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "DiacriticalLeftRightArrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "DiacriticalLeftRightVector" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "DiacriticalLeftVector" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "DiacriticalRightArrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "DiacriticalRightVector" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "DiacriticalTilde" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "Diamond" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "DifferentialD" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Dopf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Dot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "DotDot" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "DotEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "DoubleContourIntegral" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "DoubleDot" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "DoubleDownArrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "DoubleLeftArrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "DoubleLeftRightArrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "DoubleLeftTee" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "DoubleLongLeftArrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "DoubleLongLeftRightArrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "DoubleLongRightArrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "DoubleRightArrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "DoubleRightTee" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "DoubleUpArrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "DoubleUpDownArrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "DoubleVerticalBar" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "DownArrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "DownArrowBar" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "DownArrowUpArrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "DownBreve" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "DownLeftRightVector" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "DownLeftTeeVector" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "DownLeftVector" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "DownLeftVectorBar" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "DownRightTeeVector" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "DownRightVector" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "DownRightVectorBar" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "DownTee" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "DownTeeArrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Downarrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Dscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Dstrok" },
    { { HTML_PLUS }, { HTML_PLUS }, "EEgr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ENG" },
    { { HTML_1_0 }, { HTML_UNDEF }, "ETH" },
    { { HTML_1_0 }, { HTML_UNDEF }, "Eacute" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Ecaron" },
    { { HTML_1_0 }, { HTML_UNDEF }, "Ecirc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Ecy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Edot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Efr" },
    { { HTML_PLUS }, { HTML_PLUS }, "Egr" },
    { { HTML_1_0 }, { HTML_UNDEF }, "Egrave" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "Element" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Emacr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "EmptySmallSquare" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "EmptyVerySmallSquare" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Eogon" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Eopf" },
    { { HTML_4_0 }, { HTML_UNDEF }, "Epsilon" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "Equal" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "EqualTilde" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "Equilibrium" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Escr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Esim" },
    { { HTML_4_0 }, { HTML_UNDEF }, "Eta" },
    { { HTML_1_0 }, { HTML_UNDEF }, "Euml" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "Exists" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ExponentialE" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Fcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Ffr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "FilledSmallSquare" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "FilledVerySmallSquare" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Fopf" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "ForAll" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Fouriertrf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Fscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "GJcy" },
    { { HTML_PLUS }, { HTML_UNDEF }, "Gamma" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Gammad" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Gbreve" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Gcedil" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Gcirc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Gcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Gdot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Gfr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Gg" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "GoodBreak" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Gopf" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "GreaterEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "GreaterEqualLess" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "GreaterFullEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "GreaterGreater" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "GreaterLess" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "GreaterSlantEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "GreaterTilde" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Gscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Gt" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "HARDcy" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "Hacek" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "Hat" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Hcirc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Hfr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "HilbertSpace" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Hopf" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "HorizontalLine" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Hscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Hstrok" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "HumpDownHump" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "HumpEqual" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "IEcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "IJlig" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "IOcy" },
    { { HTML_1_0 }, { HTML_UNDEF }, "Iacute" },
    { { HTML_1_0 }, { HTML_UNDEF }, "Icirc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Icy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Idot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Ifr" },
    { { HTML_PLUS }, { HTML_PLUS }, "Igr" },
    { { HTML_1_0 }, { HTML_UNDEF }, "Igrave" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Im" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Imacr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ImaginaryI" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "Implies" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "IndentingNewLine" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Int" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "Integral" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "Intersection" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "InvisibleComma" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "InvisibleTimes" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Iogon" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Iopf" },
    { { HTML_4_0 }, { HTML_UNDEF }, "Iota" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Iscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Itilde" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Iukcy" },
    { { HTML_1_0 }, { HTML_UNDEF }, "Iuml" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Jcirc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Jcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Jfr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Jopf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Jscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Jsercy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Jukcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "KHcy" },
    { { HTML_PLUS }, { HTML_PLUS }, "KHgr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "KJcy" },
    { { HTML_4_0 }, { HTML_UNDEF }, "Kappa" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Kcedil" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Kcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Kfr" },
    { { HTML_PLUS }, { HTML_PLUS }, "Kgr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Kopf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Kscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "LJcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Lacute" },
    { { HTML_PLUS }, { HTML_UNDEF }, "Lambda" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Lang" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Laplacetrf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Larr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Lcaron" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Lcedil" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Lcy" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "LeftAngleBracket" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "LeftArrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "LeftArrowBar" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "LeftArrowRightArrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "LeftBracketingBar" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "LeftCeiling" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "LeftDoubleBracket" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "LeftDoubleBracketingBar" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "LeftDownTeeVector" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "LeftDownVector" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "LeftDownVectorBar" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "LeftFloor" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "LeftRightArrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "LeftRightVector" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "LeftSkeleton" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "LeftTee" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "LeftTeeArrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "LeftTeeVector" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "LeftTriangle" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "LeftTriangleBar" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "LeftTriangleEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "LeftUpDownVector" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "LeftUpTeeVector" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "LeftUpVector" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "LeftUpVectorBar" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "LeftVector" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "LeftVectorBar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Leftarrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Leftrightarrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "LessEqualGreater" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "LessFullEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "LessGreater" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "LessLess" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "LessSlantEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "LessTilde" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Lfr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Ll" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Lleftarrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Lmidot" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "LongLeftArrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "LongLeftRightArrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "LongRightArrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Longleftarrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Longleftrightarrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Longrightarrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Lopf" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "LowerLeftArrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "LowerRightArrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Lscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Lsh" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Lstrok" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Lt" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Map" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Mcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "MediumSpace" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Mellintrf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Mfr" },
    { { HTML_PLUS }, { HTML_PLUS }, "Mgr" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "MinusPlus" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Mopf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Mscr" },
    { { HTML_4_0 }, { HTML_UNDEF }, "Mu" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "NJcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Nacute" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "NaN" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Ncaron" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Ncedil" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Ncy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "NegativeMediumSpace" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "NegativeThickSpace" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "NegativeThinSpace" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "NegativeVeryThinSpace" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "NestedGreaterGreater" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "NestedLessLess" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "NewLine" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Nfr" },
    { { HTML_PLUS }, { HTML_PLUS }, "Ngr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "NoBreak" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "NonBreakingSpace" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Nopf" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "Not" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "NotANumber" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "NotCongruent" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "NotCupCap" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "NotDoubleVerticalBar" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "NotElement" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "NotEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "NotEqualTilde" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "NotExists" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "NotGreater" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "NotGreaterEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "NotGreaterFullEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "NotGreaterGreater" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "NotGreaterLess" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "NotGreaterSlantEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "NotGreaterTilde" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "NotHumpDownHump" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "NotHumpEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "NotLeftTriangle" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "NotLeftTriangleBar" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "NotLeftTriangleEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "NotLess" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "NotLessEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "NotLessFullEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "NotLessGreater" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "NotLessLess" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "NotLessSlantEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "NotLessTilde" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "NotNestedGreaterGreater" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "NotNestedLessLess" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "NotPrecedes" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "NotPrecedesEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "NotPrecedesSlantEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "NotPrecedesTilde" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "NotReverseElement" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "NotRightTriangle" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "NotRightTriangleBar" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "NotRightTriangleEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "NotSquareSubset" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "NotSquareSubsetEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "NotSquareSuperset" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "NotSquareSupersetEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "NotSubset" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "NotSubsetEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "NotSucceeds" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "NotSucceedsEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "NotSucceedsSlantEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "NotSucceedsTilde" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "NotSuperset" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "NotSupersetEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "NotTilde" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "NotTildeEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "NotTildeFullEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "NotTildeTilde" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "NotVerticalBar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Nscr" },
    { { HTML_1_0 }, { HTML_UNDEF }, "Ntilde" },
    { { HTML_4_0 }, { HTML_UNDEF }, "Nu" },
    { { HTML_4_0 }, { HTML_UNDEF }, "OElig" },
    { { HTML_1_0 }, { HTML_UNDEF }, "Oacute" },
    { { HTML_1_0 }, { HTML_UNDEF }, "Ocirc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Ocy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Odblac" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Ofr" },
    { { HTML_PLUS }, { HTML_PLUS }, "Ogr" },
    { { HTML_1_0 }, { HTML_UNDEF }, "Ograve" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Omacr" },
    { { HTML_PLUS }, { HTML_UNDEF }, "Omega" },
    { { HTML_4_0 }, { HTML_UNDEF }, "Omicron" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Oopf" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "OpenCurlyDoubleQuote" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "OpenCurlyQuote" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "Or" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Oscr" },
    { { HTML_1_0 }, { HTML_UNDEF }, "Oslash" },
    { { HTML_1_0 }, { HTML_UNDEF }, "Otilde" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Otimes" },
    { { HTML_1_0 }, { HTML_UNDEF }, "Ouml" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "OverBar" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "OverBrace" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "OverBracket" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "OverParenthesis" },
    { { HTML_PLUS }, { HTML_PLUS }, "PHgr" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "PartialD" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Pcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Pfr" },
    { { HTML_4_0 }, { HTML_UNDEF }, "Phi" },
    { { HTML_PLUS }, { HTML_UNDEF }, "Pi" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "PlusMinus" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Poincareplane" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Popf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Pr" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "Precedes" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "PrecedesEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "PrecedesSlantEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "PrecedesTilde" },
    { { HTML_PLUS }, { HTML_UNDEF }, "Prime" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "Product" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "Proportion" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "Proportional" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Pscr" },
    { { HTML_PLUS }, { HTML_UNDEF }, "Psi" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "QUOT" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Qfr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Qopf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Qscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "RBarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "REG" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Racute" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Rang" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Rarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Rarrtl" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Rcaron" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Rcedil" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Rcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Re" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "ReverseElement" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "ReverseEquilibrium" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "ReverseUpEquilibrium" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Rfr" },
    { { HTML_PLUS }, { HTML_PLUS }, "Rgr" },
    { { HTML_4_0 }, { HTML_UNDEF }, "Rho" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "RightAngleBracket" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "RightArrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "RightArrowBar" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "RightArrowLeftArrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "RightBracketingBar" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "RightCeiling" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "RightDoubleBracket" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "RightDoubleBracketingBar" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "RightDownTeeVector" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "RightDownVector" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "RightDownVectorBar" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "RightFloor" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "RightSkeleton" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "RightTee" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "RightTeeArrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "RightTeeVector" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "RightTriangle" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "RightTriangleBar" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "RightTriangleEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "RightUpDownVector" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "RightUpTeeVector" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "RightUpVector" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "RightUpVectorBar" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "RightVector" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "RightVectorBar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Rightarrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Ropf" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "RoundImplies" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Rrightarrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Rscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Rsh" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "RuleDelayed" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "SHCHcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "SHcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "SOFTcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Sacute" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Sc" },
    { { HTML_4_0 }, { HTML_UNDEF }, "Scaron" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Scedil" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Scirc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Scy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Sfr" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "ShortDownArrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "ShortLeftArrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "ShortRightArrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "ShortUpArrow" },
    { { HTML_PLUS }, { HTML_UNDEF }, "Sigma" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "SmallCircle" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Sopf" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "Space" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "Sqrt" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "Square" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "SquareIntersection" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "SquareSubset" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "SquareSubsetEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "SquareSuperset" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "SquareSupersetEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "SquareUnion" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Sscr" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "Star" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Sub" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "Subset" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "SubsetEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "Succeeds" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "SucceedsEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "SucceedsSlantEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "SucceedsTilde" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "SuchThat" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "Sum" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Sup" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "Superset" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "SupersetEqual" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Supset" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "Tab" },
    { { HTML_1_0 }, { HTML_UNDEF }, "THORN" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "TRADE" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "TSHcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "TScy" },
    { { HTML_4_0 }, { HTML_UNDEF }, "Tau" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Tcaron" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Tcedil" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Tcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Tfr" },
    { { HTML_PLUS }, { HTML_PLUS }, "Tgr" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "Therefore" },
    { { HTML_PLUS }, { HTML_UNDEF }, "Theta" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "ThinSpace" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "ThickSpace" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "Tilde" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "TildeEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "TildeFullEqual" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "TildeTilde" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Topf" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "TripleDot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Tscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Tstrok" },
    { { HTML_1_0 }, { HTML_UNDEF }, "Uacute" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Uarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Uarrocir" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Ubrcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Ubreve" },
    { { HTML_1_0 }, { HTML_UNDEF }, "Ucirc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Ucy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Udblac" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Ufr" },
    { { HTML_1_0 }, { HTML_UNDEF }, "Ugrave" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Umacr" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "UnderBar" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "UnderBrace" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "UnderBracket" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "UnderParenthesis" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "Union" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "UnionPlus" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Uogon" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Uopf" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "UpArrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "UpArrowBar" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "UpArrowDownArrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "UpDownArrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "UpEquilibrium" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "UpTee" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "UpTeeArrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Uparrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Updownarrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "UpperLeftArrow" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "UpperRightArrow" },
    { { HTML_PLUS }, { HTML_UNDEF }, "Upsi" },
    { { HTML_4_0 }, { HTML_UNDEF }, "Upsilon" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Uring" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Uscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Utilde" },
    { { HTML_1_0 }, { HTML_UNDEF }, "Uuml" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "VDash" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Vbar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Vcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Vdash" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Vdashl" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "Vee" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Verbar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Vert" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "VerticalBar" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "VerticalLine" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "VerticalSeparator" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "VerticalTilde" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "VeryThinSpace" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Vfr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Vopf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Vscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Vvdash" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Wcirc" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "Wedge" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Wfr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Wopf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Wscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Xfr" },
    { { HTML_PLUS }, { HTML_UNDEF }, "Xi" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Xopf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Xscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "YAcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "YIcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "YUcy" },
    { { HTML_1_0 }, { HTML_UNDEF }, "Yacute" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Ycirc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Ycy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Yfr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Yopf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Yscr" },
    { { HTML_4_0 }, { HTML_UNDEF }, "Yuml" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ZHcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Zacute" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Zcaron" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Zcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Zdot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ZeroWidthSpace" },
    { { HTML_4_0 }, { HTML_UNDEF }, "Zeta" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Zfr" },
    { { HTML_PLUS }, { HTML_PLUS }, "Zgr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Zopf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "Zscr" },
    { { HTML_1_0 }, { HTML_UNDEF }, "aacute" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "abreve" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ac" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "acd" },
    { { HTML_1_0 }, { HTML_UNDEF }, "acirc" },
    { { HTML_1_0 }, { HTML_UNDEF }, "acute" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "acy" },
    { { HTML_1_0 }, { HTML_UNDEF }, "aelig" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "af" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "afr" },
    { { HTML_1_0 }, { HTML_UNDEF }, "agrave" },
    { { HTML_4_0 }, { HTML_UNDEF }, "alefsym" },
    { { HTML_PLUS }, { HTML_UNDEF }, "aleph" },
    { { HTML_PLUS }, { HTML_UNDEF }, "alpha" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "amacr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "amalg" },
    { { HTML_TAGS }, { HTML_UNDEF }, "amp" },
    { { HTML_PLUS }, { HTML_UNDEF }, "and" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "andand" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "andd" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "andslope" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "andv" },
    { { HTML_PLUS }, { HTML_UNDEF }, "ang" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ange" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "angle" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "angmsd" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "angmsdaa" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "angmsdab" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "angmsdac" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "angmsdad" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "angmsdae" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "angmsdaf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "angmsdag" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "angmsdah" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "angrt" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "angrtvb" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "angrtvbd" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "angsph" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "angst" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "angzarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "aogon" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "aopf" },
    { { HTML_PLUS }, { HTML_UNDEF }, "ap" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "apE" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "apacir" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ape" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "apid" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "apos" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "approx" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "approxeq" },
    { { HTML_1_0 }, { HTML_UNDEF }, "aring" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ascr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ast" },
    { { HTML_4_0 }, { HTML_UNDEF }, "asymp" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "asympeq" },
    { { HTML_1_0 }, { HTML_UNDEF }, "atilde" },
    { { HTML_1_0 }, { HTML_UNDEF }, "auml" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "awconint" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "awint" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "bNot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "backcong" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "backepsilon" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "backprime" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "backsim" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "backsimeq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "bang" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "barvee" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "barwed" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "barwedge" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "bbrk" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "bbrktbrk" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "bcong" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "bcy" },
    { { HTML_4_0 }, { HTML_UNDEF }, "bdquo" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "becaus" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "because" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "bemptyv" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "bepsi" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "bernou" },
    { { HTML_PLUS }, { HTML_UNDEF }, "beta" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "beth" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "between" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "bfr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "bigcap" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "bigcirc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "bigcup" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "bigodot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "bigoplus" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "bigotimes" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "bigsqcup" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "bigstar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "bigtriangledown" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "bigtriangleup" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "biguplus" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "bigvee" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "bigwedge" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "bkarow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "blacklozenge" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "blacksquare" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "blacktriangle" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "blacktriangledown" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "blacktriangleleft" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "blacktriangleright" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "blank" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "blk12" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "blk14" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "blk34" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "block" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "bnot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "bopf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "bot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "bottom" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "bowtie" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "boxDL" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "boxDR" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "boxDl" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "boxDr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "boxH" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "boxHD" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "boxHU" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "boxHd" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "boxHu" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "boxUL" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "boxUR" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "boxUl" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "boxUr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "boxV" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "boxVH" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "boxVL" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "boxVR" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "boxVh" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "boxVl" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "boxVr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "boxbox" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "boxdL" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "boxdR" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "boxdl" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "boxdr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "boxh" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "boxhD" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "boxhU" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "boxhd" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "boxhu" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "boxminus" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "boxplus" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "boxtimes" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "boxuL" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "boxuR" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "boxul" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "boxur" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "boxv" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "boxvH" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "boxvL" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "boxvR" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "boxvh" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "boxvl" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "boxvr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "bprime" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "breve" },
    { { HTML_1_0 }, { HTML_UNDEF }, "brvbar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "bscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "bsemi" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "bsim" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "bsime" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "bsol" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "bsolb" },
    { { HTML_PLUS }, { HTML_UNDEF }, "bull" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "bullet" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "bump" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "bumpE" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "bumpe" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "bumpeq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "cacute" },
    { { HTML_PLUS }, { HTML_UNDEF }, "cap" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "capand" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "capbrcup" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "capcap" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "capcup" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "capdot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "caret" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "caron" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ccaps" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ccaron" },
    { { HTML_1_0 }, { HTML_UNDEF }, "ccedil" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ccirc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ccups" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ccupssm" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "cdot" },
    { { HTML_3_0 }, { HTML_3_0 }, "cdots" },
    { { HTML_1_0 }, { HTML_UNDEF }, "cedil" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "cemptyv" },
    { { HTML_1_0 }, { HTML_UNDEF }, "cent" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "centerdot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "cfr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "chcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "check" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "checkmark" },
    { { HTML_PLUS }, { HTML_UNDEF }, "chi" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "cir" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "cirE" },
    { { HTML_4_0 }, { HTML_UNDEF }, "circ" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "circeq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "circlearrowleft" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "circlearrowright" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "circledR" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "circledS" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "circledast" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "circledcirc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "circleddash" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "cire" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "cirfnint" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "cirmid" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "cirscir" },
    { { HTML_PLUS }, { HTML_UNDEF }, "clubs" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "clubsuit" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "colon" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "colone" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "coloneq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "comma" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "commat" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "comp" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "compfn" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "complement" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "complexes" },
    { { HTML_PLUS }, { HTML_UNDEF }, "cong" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "congdot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "conint" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "copf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "coprod" },
    { { HTML_1_0 }, { HTML_UNDEF }, "copy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "copysr" },
    { { HTML_1_0 }, { HTML_UNDEF }, "cr" },
    { { HTML_4_0 }, { HTML_UNDEF }, "crarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "cross" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "cscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "csub" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "csube" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "csup" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "csupe" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ctdot" },
    { { HTML_3_0 }, { HTML_3_0 }, "cub" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "cudarrl" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "cudarrr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "cuepr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "cuesc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "cularr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "cularrp" },
    { { HTML_PLUS }, { HTML_UNDEF }, "cup" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "cupbrcap" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "cupcap" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "cupcup" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "cupdot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "cupor" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "curarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "curarrm" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "curlyeqprec" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "curlyeqsucc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "curlyvee" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "curlywedge" },
    { { HTML_1_0 }, { HTML_UNDEF }, "curren" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "curvearrowleft" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "curvearrowright" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "cuvee" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "cuwed" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "cwconint" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "cwint" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "cylcty" },
    { { HTML_4_0 }, { HTML_UNDEF }, "dArr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "dHar" },
    { { HTML_4_0 }, { HTML_UNDEF }, "dagger" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "daleth" },
    { { HTML_PLUS }, { HTML_UNDEF }, "darr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "dash" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "dashv" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "dbkarow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "dblac" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "dcaron" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "dcy" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "dd" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ddagger" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ddarr" },
    { { HTML_3_0 }, { HTML_3_0 }, "ddots" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ddotseq" },
    { { HTML_1_0 }, { HTML_UNDEF }, "deg" },
    { { HTML_PLUS }, { HTML_PLUS }, "degree" },
    { { HTML_PLUS }, { HTML_UNDEF }, "delta" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "demptyv" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "dfisht" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "dfr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "dharl" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "dharr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "diam" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "diamond" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "diamondsuit" },
    { { HTML_PLUS }, { HTML_UNDEF }, "diams" },
    { { HTML_PLUS }, { HTML_UNDEF }, "die" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "digamma" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "disin" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "div" },
    { { HTML_1_0 }, { HTML_UNDEF }, "divide" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "divideontimes" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "divonx" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "djcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "dlcorn" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "dlcrop" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "dollar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "dopf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "dot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "doteq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "doteqdot" },
    { { HTML_3_0 }, { HTML_3_0 }, "dotfill" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "dotminus" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "dotplus" },
    { { HTML_3_0 }, { HTML_3_0 }, "dots" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "dotsquare" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "doublebarwedge" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "downarrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "downdownarrows" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "downharpoonleft" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "downharpoonright" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "drbkarow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "drcorn" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "drcrop" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "dscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "dscy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "dsol" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "dstrok" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "dtdot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "dtri" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "dtrif" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "duarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "duhar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "dwangle" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "dzcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "dzigrarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "eDDot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "eDot" },
    { { HTML_1_0 }, { HTML_UNDEF }, "eacute" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "easter" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ecaron" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ecir" },
    { { HTML_1_0 }, { HTML_UNDEF }, "ecirc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ecolon" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ecy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "edot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ee" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "efDot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "efr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "eg" },
    { { HTML_1_0 }, { HTML_UNDEF }, "egrave" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "egs" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "egsdot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "el" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "elinters" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ell" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "els" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "elsdot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "emacr" },
    { { HTML_PLUS }, { HTML_UNDEF }, "empty" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "emptyset" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "emptyv" },
    { { HTML_3_0, HV_NOT32 }, { HTML_UNDEF }, "emsp" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "emsp13" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "emsp14" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "eng" },
    { { HTML_3_0, HV_NOT32 }, { HTML_UNDEF }, "ensp" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "eogon" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "eopf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "epar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "eparsl" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "eplus" },
    { { HTML_PLUS }, { HTML_UNDEF }, "epsi" },
    { { HTML_3_0 }, { HTML_UNDEF }, "epsilon" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "epsiv" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "eqcirc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "eqcolon" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "eqsim" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "eqslantgtr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "eqslantless" },
    { { HTML_3_0 }, { HTML_UNDEF }, "equals" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "equest" },
    { { HTML_PLUS }, { HTML_UNDEF }, "equiv" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "equivDD" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "eqvparsl" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "erDot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "erarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "escr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "esdot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "esim" },
    { { HTML_PLUS }, { HTML_UNDEF }, "eta" },
    { { HTML_1_0 }, { HTML_UNDEF }, "eth" },
    { { HTML_1_0 }, { HTML_UNDEF }, "euml" },
    { { HTML_4_0 }, { HTML_UNDEF }, "euro" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "excl" },
    { { HTML_PLUS }, { HTML_UNDEF }, "exist" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "expectation" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "exponentiale" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "fallingdotseq" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "false" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "fcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "female" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ffilig" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "fflig" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ffllig" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ffr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "filig" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "flat" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "fllig" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "fltns" },
    { { HTML_4_0 }, { HTML_UNDEF }, "fnof" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "fopf" },
    { { HTML_PLUS }, { HTML_UNDEF }, "forall" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "fork" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "forkv" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "fpartint" },
    { { HTML_1_0 }, { HTML_UNDEF }, "frac12" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "frac13" },
    { { HTML_1_0 }, { HTML_UNDEF }, "frac14" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "frac15" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "frac16" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "frac18" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "frac23" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "frac25" },
    { { HTML_1_0 }, { HTML_UNDEF }, "frac34" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "frac35" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "frac38" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "frac45" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "frac56" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "frac58" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "frac78" },
    { { HTML_4_0 }, { HTML_UNDEF }, "frasl" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "frown" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "fscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "gE" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "gEl" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "gacute" },
    { { HTML_PLUS }, { HTML_UNDEF }, "gamma" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "gammad" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "gap" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "gbreve" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "gcirc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "gcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "gdot" },
    { { HTML_PLUS }, { HTML_UNDEF }, "ge" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "gel" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "geq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "geqq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "geqslant" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ges" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "gescc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "gesdot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "gesdoto" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "gesdotol" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "gesles" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "gfr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "gg" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ggg" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "gimel" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "gjcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "gl" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "glE" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "gla" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "glj" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "gnE" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "gnap" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "gnapprox" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "gne" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "gneq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "gneqq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "gnsim" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "gopf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "grave" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "gscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "gsim" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "gsime" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "gsiml" },
    { { HTML_TAGS }, { HTML_UNDEF }, "gt" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "gtcc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "gtcir" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "gtdot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "gtlPar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "gtquest" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "gtrapprox" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "gtrarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "gtrdot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "gtreqless" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "gtreqqless" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "gtrless" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "gtrsim" },
    { { HTML_PLUS}, { HTML_UNDEF }, "hArr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "hairsp" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "half" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "hamilt" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "hardcy" },
    { { HTML_PLUS }, { HTML_UNDEF }, "harr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "harrcir" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "harrw" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "hash" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "hbar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "hcirc" },
    { { HTML_PLUS }, { HTML_UNDEF }, "hearts" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "heartsuit" },
    { { HTML_PLUS }, { HTML_UNDEF }, "hellip" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "hercon" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "hfr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "hksearow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "hkswarow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "hoarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "homtht" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "hookleftarrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "hookrightarrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "hopf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "horbar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "hscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "hslash" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "hstrok" },
    { { HTML_1_0 }, { HTML_UNDEF }, "ht" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "hybull" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "hyphen" },
    { { HTML_1_0 }, { HTML_UNDEF }, "iacute" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ic" },
    { { HTML_1_0 }, { HTML_UNDEF }, "icirc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "icy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "iecy" },
    { { HTML_1_0 }, { HTML_UNDEF }, "iexcl" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "iff" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ifr" },
    { { HTML_1_0 }, { HTML_UNDEF }, "igrave" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ii" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "iiiint" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "iiint" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "iinfin" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "iiota" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ijlig" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "imacr" },
    { { HTML_PLUS }, { HTML_UNDEF }, "image" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "imagline" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "imagpart" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "imath" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "imof" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "imped" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "in" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "incare" },
    { { HTML_3_0 }, { HTML_3_0 }, "inf" },
    { { HTML_PLUS }, { HTML_UNDEF }, "infin" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "infty" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "infintie" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "inodot" },
    { { HTML_PLUS }, { HTML_UNDEF }, "int" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "intcal" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "integers" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "intercal" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "intlarhk" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "intprod" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "iocy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "iogon" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "iopf" },
    { { HTML_PLUS }, { HTML_UNDEF }, "iota" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "iprod" },
    { { HTML_1_0 }, { HTML_UNDEF }, "iquest" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "iscr" },
    { { HTML_PLUS }, { HTML_UNDEF }, "isin" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "isinE" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "isindot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "isins" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "isinsv" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "isinv" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "it" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "itilde" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "iukcy" },
    { { HTML_1_0 }, { HTML_UNDEF }, "iuml" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "jcirc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "jcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "jfr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "jmath" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "jopf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "jscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "jsercy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "jukcy" },
    { { HTML_PLUS }, { HTML_UNDEF }, "kappa" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "kappav" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "kcedil" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "kcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "kfr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "kgreen" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "khcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "kjcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "kopf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "kscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lAarr" },
    { { HTML_PLUS }, { HTML_UNDEF }, "lArr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lAtail" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lBarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lE" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lEg" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lHar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lacute" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "laemptyv" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lagran" },
    { { HTML_PLUS }, { HTML_UNDEF }, "lambda" },
    { { HTML_PLUS }, { HTML_UNDEF }, "lang" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "langd" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "langle" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lap" },
    { { HTML_1_0 }, { HTML_UNDEF }, "laquo"  },
    { { HTML_PLUS }, { HTML_UNDEF }, "larr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "larrb" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "larrbfs" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "larrfs" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "larrhk" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "larrlp" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "larrpl" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "larrsim" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "larrtl" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lat" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "latail" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "late" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lbarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lbbrk" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lbrace" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lbrack" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lbrke" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lbrksld" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lbrkslu" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lcaron" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lcedil" },
    { { HTML_PLUS }, { HTML_UNDEF }, "lceil" },
    { { HTML_3_0 }, { HTML_UNDEF }, "lcub" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ldca" },
    { { HTML_3_0 }, { HTML_3_0 }, "ldots" },
    { { HTML_4_0 }, { HTML_UNDEF }, "ldquo" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ldquor" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ldrdhar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ldrushar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ldsh" },
    { { HTML_PLUS }, { HTML_UNDEF }, "le" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "leftarrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "leftarrowtail" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "leftharpoondown" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "leftharpoonup" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "leftleftarrows" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "leftrightarrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "leftrightarrows" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "leftrightharpoons" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "leftrightsquigarrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "leftthreetimes" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "leg" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "leq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "leqq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "leqslant" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "les" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lescc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lesdot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lesdoto" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lesdotor" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lesges" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lessapprox" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lessdot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lesseqgtr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lesseqqgtr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lessgtr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lesssim" },
    { { HTML_1_0 }, { HTML_UNDEF }, "lf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lfisht" },
    { { HTML_PLUS }, { HTML_UNDEF }, "lfloor" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lfr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lg" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lgE" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lhard" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lharu" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lharul" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lhblk" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ljcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ll" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "llarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "llcorner" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "llhard" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lltri" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lmidot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lmoust" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lmoustache" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lnE" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lnap" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lnapprox" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lne" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lneq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lneqq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lnsim" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "loang" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "loarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lobrk" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "longleftarrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "longleftrightarrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "longmapsto" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "longrightarrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "looparrowleft" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "looparrowright" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lopar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lopf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "loplus" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lotimes" },
    { { HTML_PLUS }, { HTML_UNDEF }, "lowast" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lowbar" },
    { { HTML_PLUS }, { HTML_UNDEF }, "loz" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lozenge" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lozf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lpar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lparlt" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lrarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lrcorner" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lrhar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lrhard" },
    { { HTML_2_0, HV_RFC_2070 | HV_NOT3 }, { HTML_UNDEF }, "lrm" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lrtri" },
    { { HTML_4_0 }, { HTML_UNDEF }, "lsaquo" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lsh" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lsim" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lsime" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lsimg" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lsqb" },
    { { HTML_4_0 }, { HTML_UNDEF }, "lsquo" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lsquor" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lstrok" },
    { { HTML_TAGS }, { HTML_UNDEF }, "lt" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ltcc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ltcir" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ltdot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lthree" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ltimes" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ltlarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ltquest" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ltrPar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ltri" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ltrie" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ltrif" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "lurdshar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "luruhar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "mDDot" },
    { { HTML_1_0 }, { HTML_UNDEF }, "macr" },
    { { HTML_PLUS }, { HTML_PLUS }, "macron" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "male" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "malt" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "maltese" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "map" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "mapsto" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "mapstodown" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "mapstoleft" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "mapstoup" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "marker" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "mcomma" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "mcy" },
    { { HTML_3_0, HV_NOT32 }, { HTML_UNDEF }, "mdash" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "measuredangle" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "mfr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "mho" },
    { { HTML_1_0 }, { HTML_UNDEF }, "micro" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "mid" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "midast" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "midcir" },
    { { HTML_1_0 }, { HTML_UNDEF }, "middot" },
    { { HTML_PLUS }, { HTML_UNDEF }, "minus" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "minusb" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "minusd" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "minusdu" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "mlcp" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "mldr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "mnplus" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "models" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "mopf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "mp" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "mscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "mstpos" },
    { { HTML_PLUS }, { HTML_UNDEF }, "mu" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "multimap" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "mumap" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nLeftarrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nLeftrightarrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nRightarrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nVDash" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nVdash" },
    { { HTML_PLUS }, { HTML_UNDEF }, "nabla" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nacute" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nap" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "napos" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "napprox" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "nasymp" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "natur" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "natural" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "naturals" },
    { { HTML_1_0 }, { HTML_UNDEF }, "nbsp" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "nbump" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "nbumpe" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ncap" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ncaron" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ncedil" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ncong" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ncup" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ncy" },
    { { HTML_3_0, HV_NOT32 }, { HTML_UNDEF }, "ndash" },
    { { HTML_PLUS }, { HTML_UNDEF }, "ne" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "neArr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nearhk" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nearr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nearrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nequiv" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nesear" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "nesim" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nexist" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nexists" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nfr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nge" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ngeq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ngsim" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ngt" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ngtr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nhArr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nharr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nhpar" },
    { { HTML_PLUS }, { HTML_UNDEF }, "ni" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nis" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nisd" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "niv" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "njcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nlArr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nlarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nldr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nle" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nleftarrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nleftrightarrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nleq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nless" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nlsim" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nlt" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nltri" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nltrie" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nmid" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nopf" },
    { { HTML_1_0 }, { HTML_UNDEF }, "not" },
    { { HTML_PLUS }, { HTML_UNDEF }, "notin" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "notinva" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "notinvb" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "notinvc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "notni" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "notniva" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "notnivb" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "notnivc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "npar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nparallel" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "npolint" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "npr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "npre" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nprcue" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nprec" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nrArr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nrarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nrightarrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nrtri" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nrtrie" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nsc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nsccue" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nshortmid" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nshortparallel" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nsim" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nsime" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nsimeq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nsmid" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nspar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nsqsube" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nsqsupe" },
    { { HTML_PLUS }, { HTML_UNDEF }, "nsub" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nsube" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nsubseteq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nsucc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nsup" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nsupe" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nsupseteq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ntgl" },
    { { HTML_1_0 }, { HTML_UNDEF }, "ntilde" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ntlg" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ntriangleleft" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ntrianglelefteq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ntriangleright" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ntrianglerighteq" },
    { { HTML_PLUS }, { HTML_UNDEF }, "nu" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "num" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "numero" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "numsp" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nvDash" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nvHarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nvdash" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nvinfin" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nvlArr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nvrArr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nwArr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nwarhk" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nwarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nwarrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "nwnear" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "oS" },
    { { HTML_1_0 }, { HTML_UNDEF }, "oacute" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "oast" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "obar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ocir" },
    { { HTML_1_0 }, { HTML_UNDEF }, "ocirc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ocy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "odash" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "odblac" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "odiv" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "odot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "odsold" },
    { { HTML_4_0 }, { HTML_UNDEF }, "oelig" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ofcir" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ofr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ogon" },
    { { HTML_PLUS }, { HTML_PLUS }, "ogr" },
    { { HTML_1_0 }, { HTML_UNDEF }, "ograve" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ogt" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ohbar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ohm" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "oint" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "olarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "olcir" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "olcross" },
    { { HTML_4_0 }, { HTML_UNDEF }, "oline" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "olt" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "omacr" },
    { { HTML_PLUS }, { HTML_UNDEF }, "omega" },
    { { HTML_4_0 }, { HTML_UNDEF }, "omicron" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "omid" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ominus" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "oopf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "opar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "operp" },
    { { HTML_PLUS }, { HTML_UNDEF }, "oplus" },
    { { HTML_PLUS }, { HTML_UNDEF }, "or" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "orarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ord" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "order" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "orderof" },
    { { HTML_1_0 }, { HTML_UNDEF }, "ordf" },
    { { HTML_1_0 }, { HTML_UNDEF }, "ordm" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "origof" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "oror" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "orslope" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "orv" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "oscr" },
    { { HTML_1_0 }, { HTML_UNDEF }, "oslash" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "osol" },
    { { HTML_1_0 }, { HTML_UNDEF }, "otilde" },
    { { HTML_PLUS }, { HTML_UNDEF }, "otimes" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "otimesas" },
    { { HTML_1_0 }, { HTML_UNDEF }, "ouml" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ovbar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "par" },
    { { HTML_1_0 }, { HTML_UNDEF }, "para" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "parallel" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "parsim" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "parsl" },
    { { HTML_PLUS }, { HTML_UNDEF }, "part" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "pcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "percnt" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "period" },
    { { HTML_4_0 }, { HTML_UNDEF }, "permil" },
    { { HTML_PLUS }, { HTML_UNDEF }, "perp" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "pertenk" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "pfr" },
    { { HTML_4_0 }, { HTML_UNDEF }, "phi" },
    { { HTML_PLUS }, { HTML_PLUS }, "phis" },
    { { HTML_PLUS }, { HTML_UNDEF }, "phiv" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "phmmat" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "phone" },
    { { HTML_PLUS }, { HTML_UNDEF }, "pi" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "pitchfork" },
    { { HTML_PLUS }, { HTML_UNDEF }, "piv" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "planck" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "planckh" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "plankv" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "plus" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "plusacir" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "plusb" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "pluscir" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "plusdo" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "plusdu" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "pluse" },
    { { HTML_1_0 }, { HTML_UNDEF }, "plusmn" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "plussim" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "plustwo" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "pm" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "pointint" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "popf" },
    { { HTML_1_0 }, { HTML_UNDEF }, "pound" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "pr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "prE" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "prap" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "prcue" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "pre" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "prec" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "precapprox" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "preccurlyeq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "preceq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "precnapprox" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "precneqq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "precnsim" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "precsim" },
    { { HTML_4_0 }, { HTML_UNDEF }, "prime" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "primes" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "prnE" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "prnap" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "prnsim" },
    { { HTML_PLUS }, { HTML_UNDEF }, "prod" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "profalar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "profline" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "profsurf" },
    { { HTML_PLUS }, { HTML_UNDEF }, "prop" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "propto" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "prsim" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "prurel" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "pscr" },
    { { HTML_PLUS }, { HTML_UNDEF }, "psi" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "puncsp" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "qfr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "qint" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "qopf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "qprime" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "qscr" },
    { { HTML_3_0 }, { HTML_3_0 }, "quad" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "quaternions" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "quatint" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "quest" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "questeq" },
    { { HTML_1_0 }, { HTML_UNDEF }, "quot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rAarr" },
    { { HTML_PLUS }, { HTML_UNDEF }, "rArr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rAtail" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rBarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rHar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "race" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "racute" },
    { { HTML_PLUS }, { HTML_UNDEF }, "radic" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "raemptyv" },
    { { HTML_PLUS }, { HTML_UNDEF }, "rang" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rangd" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "range" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rangle" },
    { { HTML_1_0 }, { HTML_UNDEF }, "raquo" },
    { { HTML_PLUS }, { HTML_UNDEF }, "rarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rarrap" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rarrb" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rarrbfs" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rarrc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rarrfs" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rarrhk" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rarrlp" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rarrpl" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rarrsim" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rarrtl" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rarrw" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ratail" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ratio" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rationals" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rbarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rbbrk" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rbrace" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rbrack" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rbrke" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rbrksld" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rbrkslu" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rcaron" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rcedil" },
    { { HTML_PLUS }, { HTML_UNDEF }, "rceil" },
    { { HTML_3_0 }, { HTML_UNDEF }, "rcub" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rdca" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rdldhar" },
    { { HTML_4_0 }, { HTML_UNDEF }, "rdquo" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rdquor" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rdsh" },
    { { HTML_PLUS }, { HTML_UNDEF }, "real" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "realine" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "realpart" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "reals" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rect" },
    { { HTML_1_0 }, { HTML_UNDEF }, "reg" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rfisht" },
    { { HTML_PLUS }, { HTML_UNDEF }, "rfloor" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rfr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rhard" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rharu" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rharul" },
    { { HTML_PLUS }, { HTML_UNDEF }, "rho" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rhov" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rightarrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rightarrowtail" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rightharpoondown" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rightharpoonup" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rightleftarrows" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rightleftharpoons" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rightrightarrows" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rightsquigarrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rightthreetimes" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ring" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "risingdotseq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rlarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rlhar" },
    { { HTML_2_0, HV_RFC_2070 | HV_NOT3 }, { HTML_UNDEF }, "rlm" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rmoust" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rmoustache" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rnmid" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "roang" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "roarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "robrk" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ropar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ropf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "roplus" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rotimes" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rpar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rpargt" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rppolint" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rrarr" },
    { { HTML_4_0 }, { HTML_UNDEF }, "rsaquo" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rsh" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rsqb" },
    { { HTML_4_0 }, { HTML_UNDEF }, "rsquo" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rsquor" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rthree" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rtimes" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rtri" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rtrie" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rtrif" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rtriltri" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ruluhar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "rx" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "sacute" },
    { { HTML_4_0 }, { HTML_UNDEF }, "sbquo" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "sc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "scE" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "scap" },
    { { HTML_4_0 }, { HTML_UNDEF }, "scaron" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "sccue" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "sce" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "scedil" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "scirc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "scnE" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "scnap" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "scnsim" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "scpolint" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "scsim" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "scy" },
    { { HTML_PLUS }, { HTML_UNDEF }, "sdot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "sdotb" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "sdote" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "seArr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "searhk" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "searr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "searrow" },
    { { HTML_1_0 }, { HTML_UNDEF }, "sect" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "semi" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "seswar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "setminus" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "setmn" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "sext" },
    { { HTML_PLUS }, { HTML_PLUS }, "sfgr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "sfr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "sfrown" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "sharp" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "shchcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "shcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "shortmid" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "shortparallel" },
    { { HTML_1_0 }, { HTML_UNDEF }, "shy" },
    { { HTML_PLUS }, { HTML_UNDEF }, "sigma" },
    { { HTML_4_0 }, { HTML_UNDEF }, "sigmaf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "sigmav" },
    { { HTML_PLUS }, { HTML_UNDEF }, "sim" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "simdot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "sime" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "simeq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "simg" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "simgE" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "siml" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "simlE" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "simne" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "simplus" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "simrarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "slarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "smallsetminus" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "smashp" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "smeparsl" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "smid" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "smile" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "smt" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "smte" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "softcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "sol" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "solb" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "solbar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "sopf" },
    { { HTML_1_0 }, { HTML_UNDEF }, "sp" },
    { { HTML_PLUS }, { HTML_UNDEF }, "spades" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "spadesuit" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "spar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "splat" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "sqcap" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "sqcup" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "sqsub" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "sqsube" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "sqsubset" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "sqsubseteq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "sqsup" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "sqsupe" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "sqsupset" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "sqsupseteq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "squ" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "square" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "squarf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "squf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "squiggle" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "srarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "sscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ssetmn" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ssmile" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "sstarf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "star" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "starf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "straightepsilon" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "straightphi" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "strns" },
    { { HTML_PLUS }, { HTML_UNDEF }, "sub" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "subE" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "subdot" },
    { { HTML_PLUS }, { HTML_UNDEF }, "sube" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "subedot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "submult" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "subnE" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "subne" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "subplus" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "subrarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "subset" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "subseteq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "subseteqq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "subsetneq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "subsetneqq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "subsim" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "subsub" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "subsup" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "succ" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "succapprox" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "succcurlyeq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "succeq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "succnapprox" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "succneqq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "succnsim" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "succsim" },
    { { HTML_PLUS }, { HTML_UNDEF }, "sum" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "sung" },
    { { HTML_PLUS }, { HTML_UNDEF }, "sup" },
    { { HTML_1_0 }, { HTML_UNDEF }, "sup1" },
    { { HTML_1_0 }, { HTML_UNDEF }, "sup2" },
    { { HTML_1_0 }, { HTML_UNDEF }, "sup3" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "supE" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "supdot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "supdsub" },
    { { HTML_PLUS }, { HTML_UNDEF }, "supe" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "supedot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "suphsub" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "suplarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "supmult" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "supnE" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "supne" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "supplus" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "supset" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "supseteq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "supseteqq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "supsetneq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "supsetneqq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "supsim" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "supsub" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "supsup" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "swArr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "swarhk" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "swarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "swarrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "swnwar" },
    { { HTML_1_0 }, { HTML_UNDEF }, "szlig" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "target" },
    { { HTML_PLUS }, { HTML_UNDEF }, "tau" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "tbrk" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "tcaron" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "tcedil" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "tcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "tdot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "telrec" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "tfr" },
    { { HTML_PLUS }, { HTML_UNDEF }, "there4" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "therefore" },
    { { HTML_4_0 }, { HTML_UNDEF }, "theta" },
    { { HTML_PLUS }, { HTML_PLUS }, "thetas" },
    { { HTML_4_0 }, { HTML_UNDEF }, "thetasym" },
    { { HTML_PLUS }, { HTML_UNDEF }, "thetav" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "thickapprox" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "thicksim" },
    { { HTML_3_0, HV_NOT32 }, { HTML_UNDEF }, "thinsp" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "thkap" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "thksim" },
    { { HTML_1_0 }, { HTML_UNDEF }, "thorn" },
    { { HTML_4_0 }, { HTML_UNDEF }, "tilde" },
    { { HTML_1_0 }, { HTML_UNDEF }, "times" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "timesb" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "timesbar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "timesd" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "tint" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "toea" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "top" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "topbot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "topcir" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "topf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "topfork" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "tosa" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "tprime" },
    { { HTML_PLUS }, { HTML_UNDEF }, "trade" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "triangle" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "triangledown" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "triangleleft" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "trianglelefteq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "triangleq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "triangleright" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "trianglerighteq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "tridot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "trie" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "triminus" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "triplus" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "trisb" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "tritime" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "trpezium" },
    { { XHTML_1_0 }, { HTML_UNDEF }, "true" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "tscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "tscy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "tshcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "tstrok" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "twixt" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "twoheadleftarrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "twoheadrightarrow" },
    { { HTML_4_0 }, { HTML_UNDEF }, "uArr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "uHar" },
    { { HTML_1_0 }, { HTML_UNDEF }, "uacute" },
    { { HTML_PLUS }, { HTML_UNDEF }, "uarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ubrcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ubreve" },
    { { HTML_1_0 }, { HTML_UNDEF }, "ucirc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ucy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "udarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "udblac" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "udhar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ufisht" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ufr" },
    { { HTML_1_0 }, { HTML_UNDEF }, "ugrave" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "uharl" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "uharr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "uhblk" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ulcorn" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ulcorner" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ulcrop" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ultri" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "umacr" },
    { { HTML_1_0 }, { HTML_UNDEF }, "uml" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "uogon" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "uopf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "uparrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "updownarrow" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "upharpoonleft" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "upharpoonright" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "uplus" },
    { { HTML_PLUS }, { HTML_UNDEF }, "upsi" },
    { { HTML_4_0 }, { HTML_UNDEF }, "upsih" },
    { { HTML_4_0 }, { HTML_UNDEF }, "upsilon" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "upuparrows" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "urcorn" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "urcorner" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "urcrop" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "uring" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "urtri" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "uscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "utdot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "utilde" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "utri" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "utrif" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "uuarr" },
    { { HTML_1_0 }, { HTML_UNDEF }, "uuml" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "uwangle" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "vArr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "vBar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "vBarv" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "vDash" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "vangrt" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "varepsilon" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "varkappa" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "varnothing" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "varphi" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "varpi" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "varpropto" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "varr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "varrho" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "varsigma" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "vartheta" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "vartriangleleft" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "vartriangleright" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "vcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "vdash" },
    { { HTML_3_0 }, { HTML_3_0 }, "vdots" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "vee" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "veebar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "veeeq" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "vellip" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "verbar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "vert" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "vfr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "vltri" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "vopf" },
    { { HTML_PLUS }, { HTML_PLUS }, "vprime" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "vprop" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "vrtri" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "vscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "vzigzag" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "wcirc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "wedbar" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "wedge" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "wedgeq" },
    { { HTML_PLUS }, { HTML_UNDEF }, "weierp" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "wfr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "wopf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "wp" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "wr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "wreath" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "wscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "xcap" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "xcirc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "xcup" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "xdtri" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "xfr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "xhArr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "xharr" },
    { { HTML_PLUS }, { HTML_UNDEF }, "xi" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "xlArr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "xlarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "xmap" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "xnis" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "xodot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "xopf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "xoplus" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "xotime" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "xrArr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "xrarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "xscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "xsqcup" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "xuplus" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "xutri" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "xvee" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "xwedge" },
    { { HTML_1_0 }, { HTML_UNDEF }, "yacute" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "yacy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ycirc" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "ycy" },
    { { HTML_1_0 }, { HTML_UNDEF }, "yen" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "yfr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "yicy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "yopf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "yscr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "yucy" },
    { { HTML_1_0 }, { HTML_UNDEF }, "yuml" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "zacute" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "zcaron" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "zcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "zdot" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "zeetrf" },
    { { HTML_PLUS }, { HTML_UNDEF }, "zeta" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "zfr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "zhcy" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "zigrarr" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "zopf" },
    { { HTML_JAN05 }, { HTML_UNDEF }, "zscr" },
    { { HTML_2_0, HV_RFC_2070 | HV_NOT3 }, { HTML_UNDEF }, "zwj" },
    { { HTML_2_0, HV_RFC_2070 | HV_NOT3 }, { HTML_UNDEF }, "zwnj" },

    { { HTML_UNDEF }, { HTML_UNDEF }, nullptr } };

// WARNING: some symbols may display incorrectly in some editors on some systems: edit them at your peril.
extra_t known_symbols [] =
{   { u8"Á", "Aacute" },
    { u8"á", "aacute" },
    { u8"Ă", "Abreve" },
    { u8"ă", "abreve" },
    { u8"∾", "ac" },
    { u8"∿", "acd" },
    { u8"∾̳", "acE" },
    { u8"Â", "Acirc" },
    { u8"â", "acirc" },
    { u8"´", "acute" },
    { u8"А", "Acy" },
    { u8"а", "acy" },
    { u8"Æ", "AElig" },
    { u8"æ", "aelig" },
    { u8"⁡", "af" },
    { u8"𝔄", "Afr" },
    { u8"𝔞", "afr" },
    { u8"À", "Agrave" },
    { u8"à", "agrave" },
    { u8"ℵ", "alefsym" },
    { u8"ℵ", "aleph" },
    { u8"Α", "Alpha" },
    { u8"α", "alpha" },
    { u8"Ā", "Amacr" },
    { u8"ā", "amacr" },
    { u8"⨿", "amalg" },
    { u8"&", "amp" },
    { u8"&", "AMP" },
    { u8"⩓", "And" },
    { u8"∧", "and" },
    { u8"⩕", "andand" },
    { u8"⩜", "andd" },
    { u8"⩘", "andslope" },
    { u8"⩚", "andv" },
    { u8"∠", "ang" },
    { u8"⦤", "ange" },
    { u8"∠", "angle" },
    { u8"∡", "angmsd" },
    { u8"⦨", "angmsdaa" },
    { u8"⦩", "angmsdab" },
    { u8"⦪", "angmsdac" },
    { u8"⦫", "angmsdad" },
    { u8"⦬", "angmsdae" },
    { u8"⦭", "angmsdaf" },
    { u8"⦮", "angmsdag" },
    { u8"⦯", "angmsdah" },
    { u8"∟", "angrt" },
    { u8"⊾", "angrtvb" },
    { u8"⦝", "angrtvbd" },
    { u8"∢", "angsph" },
    { u8"Å", "angst" },
    { u8"⍼", "angzarr" },
    { u8"Ą", "Aogon" },
    { u8"ą", "aogon" },
    { u8"𝔸", "Aopf" },
    { u8"𝕒", "aopf" },
    { u8"≈", "ap" },
    { u8"⩯", "apacir" },
    { u8"⩰", "apE" },
    { u8"≊", "ape" },
    { u8"≋", "apid" },
    { u8"'", "apos", false },
    { u8"⁡", "ApplyFunction" },
    { u8"≈", "approx" },
    { u8"≊", "approxeq" },
    { u8"Å", "Aring" },
    { u8"å", "aring" },
    { u8"𝒜", "Ascr" },
    { u8"𝒶", "ascr" },
    { u8"≔", "Assign" },
    { u8"*", "ast", false },
    { u8"≈", "asymp" },
    { u8"≍", "asympeq" },
    { u8"Ã", "Atilde" },
    { u8"ã", "atilde" },
    { u8"Ä", "Auml" },
    { u8"ä", "auml" },
    { u8"∳", "awconint" },
    { u8"⨑", "awint" },
    { u8"≌", "backcong" },
    { u8"϶", "backepsilon" },
    { u8"‵", "backprime" },
    { u8"∽", "backsim" },
    { u8"⋍", "backsimeq" },
    { u8"∖", "Backslash" },
    { u8"!", "bang", false },
    { u8"⫧", "Barv" },
    { u8"⊽", "barvee" },
    { u8"⌆", "Barwed" },
    { u8"⌅", "barwed" },
    { u8"⌅", "barwedge" },
    { u8"⎵", "bbrk" },
    { u8"⎶", "bbrktbrk" },
    { u8"≌", "bcong" },
    { u8"Б", "Bcy" },
    { u8"б", "bcy" },
    { u8"„", "bdquo" },
    { u8"∵", "becaus" },
    { u8"∵", "Because" },
    { u8"∵", "because" },
    { u8"⦰", "bemptyv" },
    { u8"϶", "bepsi" },
    { u8"ℬ", "bernou" },
    { u8"ℬ", "Bernoullis" },
    { u8"Β", "Beta" },
    { u8"β", "beta" },
    { u8"ℶ", "beth" },
    { u8"≬", "between" },
    { u8"𝔅", "Bfr" },
    { u8"𝔟", "bfr" },
    { u8"⋂", "bigcap" },
    { u8"◯", "bigcirc" },
    { u8"⋃", "bigcup" },
    { u8"⨀", "bigodot" },
    { u8"⨁", "bigoplus" },
    { u8"⨂", "bigotimes" },
    { u8"⨆", "bigsqcup" },
    { u8"★", "bigstar" },
    { u8"▽", "bigtriangledown" },
    { u8"△", "bigtriangleup" },
    { u8"⨄", "biguplus" },
    { u8"⋁", "bigvee" },
    { u8"⋀", "bigwedge" },
    { u8"⤍", "bkarow" },
    { u8"⧫", "blacklozenge" },
    { u8"▪", "blacksquare" },
    { u8"▴", "blacktriangle" },
    { u8"▾", "blacktriangledown" },
    { u8"◂", "blacktriangleleft" },
    { u8"▸", "blacktriangleright" },
    { u8"␣", "blank" },
    { u8"▒", "blk12" },
    { u8"░", "blk14" },
    { u8"▓", "blk34" },
    { u8"█", "block" },
    { u8"=⃥", "bne" },
    { u8"≡⃥", "bnequiv" },
    { u8"⫭", "bNot" },
    { u8"⌐", "bnot" },
    { u8"𝔹", "Bopf" },
    { u8"𝕓", "bopf" },
    { u8"⊥", "bot" },
    { u8"⊥", "bottom" },
    { u8"⋈", "bowtie" },
    { u8"⧉", "boxbox" },
    { u8"╗", "boxDL" },
    { u8"╖", "boxDl" },
    { u8"╕", "boxdL" },
    { u8"┐", "boxdl" },
    { u8"╔", "boxDR" },
    { u8"╓", "boxDr" },
    { u8"╒", "boxdR" },
    { u8"┌", "boxdr" },
    { u8"═", "boxH" },
    { u8"─", "boxh" },
    { u8"╦", "boxHD" },
    { u8"╤", "boxHd" },
    { u8"╥", "boxhD" },
    { u8"┬", "boxhd" },
    { u8"╩", "boxHU" },
    { u8"╧", "boxHu" },
    { u8"╨", "boxhU" },
    { u8"┴", "boxhu" },
    { u8"⊟", "boxminus" },
    { u8"⊞", "boxplus" },
    { u8"⊠", "boxtimes" },
    { u8"╝", "boxUL" },
    { u8"╜", "boxUl" },
    { u8"╛", "boxuL" },
    { u8"┘", "boxul" },
    { u8"╚", "boxUR" },
    { u8"╙", "boxUr" },
    { u8"╘", "boxuR" },
    { u8"└", "boxur" },
    { u8"║", "boxV" },
    { u8"│", "boxv" },
    { u8"╬", "boxVH" },
    { u8"╫", "boxVh" },
    { u8"╪", "boxvH" },
    { u8"┼", "boxvh" },
    { u8"╣", "boxVL" },
    { u8"╢", "boxVl" },
    { u8"╡", "boxvL" },
    { u8"┤", "boxvl" },
    { u8"╠", "boxVR" },
    { u8"╟", "boxVr" },
    { u8"╞", "boxvR" },
    { u8"├", "boxvr" },
    { u8"‵", "bprime" },
    { u8"˘", "Breve" },
    { u8"˘", "breve" },
    { u8"¦", "brvbar" },
    { u8"ℬ", "Bscr" },
    { u8"𝒷", "bscr" },
    { u8"⁏", "bsemi" },
    { u8"∽", "bsim" },
    { u8"⋍", "bsime" },
    { u8"\\", "bsol", false },
    { u8"⧅", "bsolb" },
    { u8"⟈", "bsolhsub" },
    { u8"•", "bull" },
    { u8"•", "bullet" },
    { u8"≎", "bump" },
    { u8"⪮", "bumpE" },
    { u8"≏", "bumpe" },
    { u8"≎", "Bumpeq" },
    { u8"≏", "bumpeq" },
    { u8"Ć", "Cacute" },
    { u8"ć", "cacute" },
    { u8"⋒", "Cap" },
    { u8"∩", "cap" },
    { u8"⩄", "capand" },
    { u8"⩉", "capbrcup" },
    { u8"⩋", "capcap" },
    { u8"⩇", "capcup" },
    { u8"⩀", "capdot" },
    { u8"ⅅ", "CapitalDifferentialD" },
    { u8"∩︀", "caps" },
    { u8"⁁", "caret" },
    { u8"ˇ", "caron" },
    { u8"ℭ", "Cayleys" },
    { u8"⩍", "ccaps" },
    { u8"Č", "Ccaron" },
    { u8"č", "ccaron" },
    { u8"Ç", "Ccedil" },
    { u8"ç", "ccedil" },
    { u8"Ĉ", "Ccirc" },
    { u8"ĉ", "ccirc" },
    { u8"∰", "Cconint" },
    { u8"⩌", "ccups" },
    { u8"⩐", "ccupssm" },
    { u8"Ċ", "Cdot" },
    { u8"ċ", "cdot" },
    { u8"¸", "cedil" },
    { u8"¸", "Cedilla" },
    { u8"⦲", "cemptyv" },
    { u8"¢", "cent" },
    { u8"·", "CenterDot" },
    { u8"·", "centerdot" },
    { u8"ℭ", "Cfr" },
    { u8"𝔠", "cfr" },
    { u8"Ч", "CHcy" },
    { u8"ч", "chcy" },
    { u8"✓", "check" },
    { u8"✓", "checkmark" },
    { u8"Χ", "Chi" },
    { u8"χ", "chi" },
    { u8"○", "cir" },
    { u8"ˆ", "circ" },
    { u8"≗", "circeq" },
    { u8"↺", "circlearrowleft" },
    { u8"↻", "circlearrowright" },
    { u8"⊛", "circledast" },
    { u8"⊚", "circledcirc" },
    { u8"⊝", "circleddash" },
    { u8"⊙", "CircleDot" },
    { u8"®", "circledR" },
    { u8"Ⓢ", "circledS" },
    { u8"⊖", "CircleMinus" },
    { u8"⊕", "CirclePlus" },
    { u8"⊗", "CircleTimes" },
    { u8"⧃", "cirE" },
    { u8"≗", "cire" },
    { u8"⨐", "cirfnint" },
    { u8"⫯", "cirmid" },
    { u8"⧂", "cirscir" },
    { u8"∲", "ClockwiseContourIntegral" },
    { u8"”", "CloseCurlyDoubleQuote" },
    { u8"’", "CloseCurlyQuote" },
    { u8"♣", "clubs" },
    { u8"♣", "clubsuit" },
    { u8"∷", "Colon" },
    { u8":", "colon", false },
    { u8"⩴", "Colone" },
    { u8"≔", "colone" },
    { u8"≔", "coloneq" },
    { u8",", "comma", false },
    { u8"@", "commat", false },
    { u8"∁", "comp" },
    { u8"∘", "compfn" },
    { u8"∁", "complement" },
    { u8"ℂ", "complexes" },
    { u8"≅", "cong" },
    { u8"⩭", "congdot" },
    { u8"≡", "Congruent" },
    { u8"∯", "Conint" },
    { u8"∮", "conint" },
    { u8"∮", "ContourIntegral" },
    { u8"ℂ", "Copf" },
    { u8"𝕔", "copf" },
    { u8"∐", "coprod" },
    { u8"∐", "Coproduct" },
    { u8"©", "copy" },
    { u8"©", "COPY" },
    { u8"℗", "copysr" },
    { u8"∳", "CounterClockwiseContourIntegral" },
    { u8"↵", "crarr" },
    { u8"⨯", "Cross" },
    { u8"✗", "cross" },
    { u8"𝒞", "Cscr" },
    { u8"𝒸", "cscr" },
    { u8"⫏", "csub" },
    { u8"⫑", "csube" },
    { u8"⫐", "csup" },
    { u8"⫒", "csupe" },
    { u8"⋯", "ctdot" },
    { u8"⤸", "cudarrl" },
    { u8"⤵", "cudarrr" },
    { u8"⋞", "cuepr" },
    { u8"⋟", "cuesc" },
    { u8"↶", "cularr" },
    { u8"⤽", "cularrp" },
    { u8"⋓", "Cup" },
    { u8"∪", "cup" },
    { u8"⩈", "cupbrcap" },
    { u8"≍", "CupCap" },
    { u8"⩆", "cupcap" },
    { u8"⩊", "cupcup" },
    { u8"⊍", "cupdot" },
    { u8"⩅", "cupor" },
    { u8"∪︀", "cups" },
    { u8"↷", "curarr" },
    { u8"⤼", "curarrm" },
    { u8"⋞", "curlyeqprec" },
    { u8"⋟", "curlyeqsucc" },
    { u8"⋎", "curlyvee" },
    { u8"⋏", "curlywedge" },
    { u8"¤", "curren" },
    { u8"↶", "curvearrowleft" },
    { u8"↷", "curvearrowright" },
    { u8"⋎", "cuvee" },
    { u8"⋏", "cuwed" },
    { u8"∲", "cwconint" },
    { u8"∱", "cwint" },
    { u8"⌭", "cylcty" },
    { u8"‡", "Dagger" },
    { u8"†", "dagger" },
    { u8"ℸ", "daleth" },
    { u8"↡", "Darr" },
    { u8"⇓", "dArr" },
    { u8"↓", "darr" },
    { u8"‐", "dash" },
    { u8"⫤", "Dashv" },
    { u8"⊣", "dashv" },
    { u8"⤏", "dbkarow" },
    { u8"˝", "dblac" },
    { u8"Ď", "Dcaron" },
    { u8"ď", "dcaron" },
    { u8"Д", "Dcy" },
    { u8"д", "dcy" },
    { u8"ⅅ", "DD" },
    { u8"ⅆ", "dd" },
    { u8"‡", "ddagger" },
    { u8"⇊", "ddarr" },
    { u8"⤑", "DDotrahd" },
    { u8"⩷", "ddotseq" },
    { u8"°", "deg" },
    { u8"∇", "Del" },
    { u8"Δ", "Delta" },
    { u8"δ", "delta" },
    { u8"⦱", "demptyv" },
    { u8"⥿", "dfisht" },
    { u8"𝔇", "Dfr" },
    { u8"𝔡", "dfr" },
    { u8"⥥", "dHar" },
    { u8"⇃", "dharl" },
    { u8"⇂", "dharr" },
    { u8"´", "DiacriticalAcute" },
    { u8"˙", "DiacriticalDot" },
    { u8"˝", "DiacriticalDoubleAcute" },
    { u8"`", "DiacriticalGrave" },
    { u8"˜", "DiacriticalTilde" },
    { u8"⋄", "diam" },
    { u8"⋄", "Diamond" },
    { u8"⋄", "diamond" },
    { u8"♦", "diamondsuit" },
    { u8"♦", "diams" },
    { u8"¨", "die" },
    { u8"ⅆ", "DifferentialD" },
    { u8"ϝ", "digamma" },
    { u8"⋲", "disin" },
    { u8"÷", "div" },
    { u8"÷", "divide" },
    { u8"⋇", "divideontimes" },
    { u8"⋇", "divonx" },
    { u8"Ђ", "DJcy" },
    { u8"ђ", "djcy" },
    { u8"⌞", "dlcorn" },
    { u8"⌍", "dlcrop" },
    { u8"$", "dollar", false },
    { u8"𝔻", "Dopf" },
    { u8"𝕕", "dopf" },
    { u8"¨", "Dot" },
    { u8"˙", "dot" },
    { u8"◌⃜", "DotDot" },
    { u8"≐", "doteq" },
    { u8"≑", "doteqdot" },
    { u8"≐", "DotEqual" },
    { u8"∸", "dotminus" },
    { u8"∔", "dotplus" },
    { u8"⊡", "dotsquare" },
    { u8"⌆", "doublebarwedge" },
    { u8"∯", "DoubleContourIntegral" },
    { u8"¨", "DoubleDot" },
    { u8"⇓", "DoubleDownArrow" },
    { u8"⇐", "DoubleLeftArrow" },
    { u8"⇔", "DoubleLeftRightArrow" },
    { u8"⫤", "DoubleLeftTee" },
    { u8"⟸", "DoubleLongLeftArrow" },
    { u8"⟺", "DoubleLongLeftRightArrow" },
    { u8"⟹", "DoubleLongRightArrow" },
    { u8"⇒", "DoubleRightArrow" },
    { u8"⊨", "DoubleRightTee" },
    { u8"⇑", "DoubleUpArrow" },
    { u8"⇕", "DoubleUpDownArrow" },
    { u8"∥", "DoubleVerticalBar" },
    { u8"↓", "DownArrow" },
    { u8"⇓", "Downarrow" },
    { u8"↓", "downarrow" },
    { u8"⤓", "DownArrowBar" },
    { u8"⇵", "DownArrowUpArrow" },
    { u8"◌̑", "DownBreve" },
    { u8"⇊", "downdownarrows" },
    { u8"⇃", "downharpoonleft" },
    { u8"⇂", "downharpoonright" },
    { u8"⥐", "DownLeftRightVector" },
    { u8"⥞", "DownLeftTeeVector" },
    { u8"↽", "DownLeftVector" },
    { u8"⥖", "DownLeftVectorBar" },
    { u8"⥟", "DownRightTeeVector" },
    { u8"⇁", "DownRightVector" },
    { u8"⥗", "DownRightVectorBar" },
    { u8"⊤", "DownTee" },
    { u8"↧", "DownTeeArrow" },
    { u8"⤐", "drbkarow" },
    { u8"⌟", "drcorn" },
    { u8"⌌", "drcrop" },
    { u8"𝒟", "Dscr" },
    { u8"𝒹", "dscr" },
    { u8"Ѕ", "DScy" },
    { u8"ѕ", "dscy" },
    { u8"⧶", "dsol" },
    { u8"Đ", "Dstrok" },
    { u8"đ", "dstrok" },
    { u8"⋱", "dtdot" },
    { u8"▿", "dtri" },
    { u8"▾", "dtrif" },
    { u8"⇵", "duarr" },
    { u8"⥯", "duhar" },
    { u8"⦦", "dwangle" },
    { u8"Џ", "DZcy" },
    { u8"џ", "dzcy" },
    { u8"⟿", "dzigrarr" },
    { u8"É", "Eacute" },
    { u8"é", "eacute" },
    { u8"⩮", "easter" },
    { u8"Ě", "Ecaron" },
    { u8"ě", "ecaron" },
    { u8"≖", "ecir" },
    { u8"Ê", "Ecirc" },
    { u8"ê", "ecirc" },
    { u8"≕", "ecolon" },
    { u8"Э", "Ecy" },
    { u8"э", "ecy" },
    { u8"⩷", "eDDot" },
    { u8"Ė", "Edot" },
    { u8"≑", "eDot" },
    { u8"ė", "edot" },
    { u8"ⅇ", "ee" },
    { u8"≒", "efDot" },
    { u8"𝔈", "Efr" },
    { u8"𝔢", "efr" },
    { u8"⪚", "eg" },
    { u8"È", "Egrave" },
    { u8"è", "egrave" },
    { u8"⪖", "egs" },
    { u8"⪘", "egsdot" },
    { u8"⪙", "el" },
    { u8"∈", "Element" },
    { u8"⏧", "elinters" },
    { u8"ℓ", "ell" },
    { u8"⪕", "els" },
    { u8"⪗", "elsdot" },
    { u8"Ē", "Emacr" },
    { u8"ē", "emacr" },
    { u8"∅", "empty" },
    { u8"∅", "emptyset" },
    { u8"◻", "EmptySmallSquare" },
    { u8"∅", "emptyv" },
    { u8"▫", "EmptyVerySmallSquare" },
    { u8" ", "emsp" },
    { u8" ", "emsp13" },
    { u8" ", "emsp14" },
    { u8"Ŋ", "ENG" },
    { u8"ŋ", "eng" },
    { u8" ", "ensp" },
    { u8"Ę", "Eogon" },
    { u8"ę", "eogon" },
    { u8"𝔼", "Eopf" },
    { u8"𝕖", "eopf" },
    { u8"⋕", "epar" },
    { u8"⧣", "eparsl" },
    { u8"⩱", "eplus" },
    { u8"ε", "epsi" },
    { u8"Ε", "Epsilon" },
    { u8"ε", "epsilon" },
    { u8"ϵ", "epsiv" },
    { u8"≖", "eqcirc" },
    { u8"≕", "eqcolon" },
    { u8"≂", "eqsim" },
    { u8"⪖", "eqslantgtr" },
    { u8"⪕", "eqslantless" },
    { u8"⩵", "Equal" },
    { u8"=", "equals", false },
    { u8"≂", "EqualTilde" },
    { u8"≟", "equest" },
    { u8"⇌", "Equilibrium" },
    { u8"≡", "equiv" },
    { u8"⩸", "equivDD" },
    { u8"⧥", "eqvparsl" },
    { u8"⥱", "erarr" },
    { u8"≓", "erDot" },
    { u8"ℰ", "Escr" },
    { u8"ℯ", "escr" },
    { u8"≐", "esdot" },
    { u8"⩳", "Esim" },
    { u8"≂", "esim" },
    { u8"Η", "Eta" },
    { u8"η", "eta" },
    { u8"Ð", "ETH" },
    { u8"ð", "eth" },
    { u8"Ë", "Euml" },
    { u8"ë", "euml" },
    { u8"€", "euro" },
    { u8"!", "excl", false },
    { u8"∃", "exist" },
    { u8"∃", "Exists" },
    { u8"ℰ", "expectation" },
    { u8"ⅇ", "ExponentialE" },
    { u8"ⅇ", "exponentiale" },
    { u8"≒", "fallingdotseq" },
    { u8"Ф", "Fcy" },
    { u8"ф", "fcy" },
    { u8"♀", "female" },
    { u8"ﬃ", "ffilig" },
    { u8"ﬀ", "fflig" },
    { u8"ﬄ", "ffllig" },
    { u8"𝔉", "Ffr" },
    { u8"𝔣", "ffr" },
    { u8"ﬁ", "filig" },
    { u8"◼", "FilledSmallSquare" },
    { u8"▪", "FilledVerySmallSquare" },
    { u8"fj", "fjlig" },
    { u8"♭", "flat" },
    { u8"ﬂ", "fllig" },
    { u8"▱", "fltns" },
    { u8"ƒ", "fnof" },
    { u8"𝔽", "Fopf" },
    { u8"𝕗", "fopf" },
    { u8"∀", "ForAll" },
    { u8"∀", "forall" },
    { u8"⋔", "fork" },
    { u8"⫙", "forkv" },
    { u8"ℱ", "Fouriertrf" },
    { u8"⨍", "fpartint" },
    { u8"½", "frac12" },
    { u8"⅓", "frac13" },
    { u8"¼", "frac14" },
    { u8"⅕", "frac15" },
    { u8"⅙", "frac16" },
    { u8"⅛", "frac18" },
    { u8"⅔", "frac23" },
    { u8"⅖", "frac25" },
    { u8"¾", "frac34" },
    { u8"⅗", "frac35" },
    { u8"⅜", "frac38" },
    { u8"⅘", "frac45" },
    { u8"⅚", "frac56" },
    { u8"⅝", "frac58" },
    { u8"⅞", "frac78" },
    { u8"⁄", "frasl" },
    { u8"⌢", "frown" },
    { u8"ℱ", "Fscr" },
    { u8"𝒻", "fscr" },
    { u8"ǵ", "gacute" },
    { u8"Γ", "Gamma" },
    { u8"γ", "gamma" },
    { u8"Ϝ", "Gammad" },
    { u8"ϝ", "gammad" },
    { u8"⪆", "gap" },
    { u8"Ğ", "Gbreve" },
    { u8"ğ", "gbreve" },
    { u8"Ģ", "Gcedil" },
    { u8"Ĝ", "Gcirc" },
    { u8"ĝ", "gcirc" },
    { u8"Г", "Gcy" },
    { u8"г", "gcy" },
    { u8"Ġ", "Gdot" },
    { u8"ġ", "gdot" },
    { u8"≧", "gE" },
    { u8"≥", "ge" },
    { u8"⪌", "gEl" },
    { u8"⋛", "gel" },
    { u8"≥", "geq" },
    { u8"≧", "geqq" },
    { u8"⩾", "geqslant" },
    { u8"⩾", "ges" },
    { u8"⪩", "gescc" },
    { u8"⪀", "gesdot" },
    { u8"⪂", "gesdoto" },
    { u8"⪄", "gesdotol" },
    { u8"⋛︀", "gesl" },
    { u8"⪔", "gesles" },
    { u8"𝔊", "Gfr" },
    { u8"𝔤", "gfr" },
    { u8"⋙", "Gg" },
    { u8"≫", "gg" },
    { u8"⋙", "ggg" },
    { u8"ℷ", "gimel" },
    { u8"Ѓ", "GJcy" },
    { u8"ѓ", "gjcy" },
    { u8"≷", "gl" },
    { u8"⪥", "gla" },
    { u8"⪒", "glE" },
    { u8"⪤", "glj" },
    { u8"⪊", "gnap" },
    { u8"⪊", "gnapprox" },
    { u8"≩", "gnE" },
    { u8"⪈", "gne" },
    { u8"⪈", "gneq" },
    { u8"≩", "gneqq" },
    { u8"⋧", "gnsim" },
    { u8"𝔾", "Gopf" },
    { u8"𝕘", "gopf" },
    { u8"`", "grave" },
    { u8"≥", "GreaterEqual" },
    { u8"⋛", "GreaterEqualLess" },
    { u8"≧", "GreaterFullEqual" },
    { u8"⪢", "GreaterGreater" },
    { u8"≷", "GreaterLess" },
    { u8"⩾", "GreaterSlantEqual" },
    { u8"≳", "GreaterTilde" },
    { u8"𝒢", "Gscr" },
    { u8"ℊ", "gscr" },
    { u8"≳", "gsim" },
    { u8"⪎", "gsime" },
    { u8"⪐", "gsiml" },
    { u8">", "gt" },
    { u8">", "GT" },
    { u8"≫", "Gt" },
    { u8"⪧", "gtcc" },
    { u8"⩺", "gtcir" },
    { u8"⋗", "gtdot" },
    { u8"⦕", "gtlPar" },
    { u8"⩼", "gtquest" },
    { u8"⪆", "gtrapprox" },
    { u8"⥸", "gtrarr" },
    { u8"⋗", "gtrdot" },
    { u8"⋛", "gtreqless" },
    { u8"⪌", "gtreqqless" },
    { u8"≷", "gtrless" },
    { u8"≳", "gtrsim" },
    { u8"≩︀", "gvertneqq" },
    { u8"≩︀", "gvnE" },
    { u8"ˇ", "Hacek" },
    { u8" ", "hairsp" },
    { u8"½", "half" },
    { u8"ℋ", "hamilt" },
    { u8"Ъ", "HARDcy" },
    { u8"ъ", "hardcy" },
    { u8"⇔", "hArr" },
    { u8"↔", "harr" },
    { u8"⥈", "harrcir" },
    { u8"↭", "harrw" },
    { u8"#", "hash", false },
    { u8"^", "Hat", false },
    { u8"ℏ", "hbar" },
    { u8"Ĥ", "Hcirc" },
    { u8"ĥ", "hcirc" },
    { u8"♥", "hearts" },
    { u8"♥", "heartsuit" },
    { u8"…", "hellip" },
    { u8"⊹", "hercon" },
    { u8"ℌ", "Hfr" },
    { u8"𝔥", "hfr" },
    { u8"ℋ", "HilbertSpace" },
    { u8"⤥", "hksearow" },
    { u8"⤦", "hkswarow" },
    { u8"⇿", "hoarr" },
    { u8"∻", "homtht" },
    { u8"↩", "hookleftarrow" },
    { u8"↪", "hookrightarrow" },
    { u8"ℍ", "Hopf" },
    { u8"𝕙", "hopf" },
    { u8"―", "horbar" },
    { u8"─", "HorizontalLine" },
    { u8"ℋ", "Hscr" },
    { u8"𝒽", "hscr" },
    { u8"ℏ", "hslash" },
    { u8"Ħ", "Hstrok" },
    { u8"ħ", "hstrok" },
    { u8"≎", "HumpDownHump" },
    { u8"≏", "HumpEqual" },
    { u8"⁃", "hybull" },
    { u8"‐", "hyphen" },
    { u8"Í", "Iacute" },
    { u8"í", "iacute" },
    { u8"⁣", "ic" },
    { u8"Î", "Icirc" },
    { u8"î", "icirc" },
    { u8"И", "Icy" },
    { u8"и", "icy" },
    { u8"İ", "Idot" },
    { u8"Е", "IEcy" },
    { u8"е", "iecy" },
    { u8"¡", "iexcl" },
    { u8"⇔", "iff" },
    { u8"ℑ", "Ifr" },
    { u8"𝔦", "ifr" },
    { u8"Ì", "Igrave" },
    { u8"ì", "igrave" },
    { u8"ⅈ", "ii" },
    { u8"⨌", "iiiint" },
    { u8"∭", "iiint" },
    { u8"⧜", "iinfin" },
    { u8"℩", "iiota" },
    { u8"Ĳ", "IJlig" },
    { u8"ĳ", "ijlig" },
    { u8"ℑ", "Im" },
    { u8"Ī", "Imacr" },
    { u8"ī", "imacr" },
    { u8"ℑ", "image" },
    { u8"ⅈ", "ImaginaryI" },
    { u8"ℐ", "imagline" },
    { u8"ℑ", "imagpart" },
    { u8"ı", "imath" },
    { u8"⊷", "imof" },
    { u8"Ƶ", "imped" },
    { u8"⇒", "Implies" },
    { u8"∈", "in" },
    { u8"℅", "incare" },
    { u8"∞", "infin" },
    { u8"⧝", "infintie" },
    { u8"ı", "inodot" },
    { u8"∬", "Int" },
    { u8"∫", "int" },
    { u8"⊺", "intcal" },
    { u8"ℤ", "integers" },
    { u8"∫", "Integral" },
    { u8"⊺", "intercal" },
    { u8"⋂", "Intersection" },
    { u8"⨗", "intlarhk" },
    { u8"⨼", "intprod" },
    { u8"⁣", "InvisibleComma" },
    { u8"⁢", "InvisibleTimes" },
    { u8"Ё", "IOcy" },
    { u8"ё", "iocy" },
    { u8"Į", "Iogon" },
    { u8"į", "iogon" },
    { u8"𝕀", "Iopf" },
    { u8"𝕚", "iopf" },
    { u8"Ι", "Iota" },
    { u8"ι", "iota" },
    { u8"⨼", "iprod" },
    { u8"¿", "iquest" },
    { u8"ℐ", "Iscr" },
    { u8"𝒾", "iscr" },
    { u8"∈", "isin" },
    { u8"⋵", "isindot" },
    { u8"⋹", "isinE" },
    { u8"⋴", "isins" },
    { u8"⋳", "isinsv" },
    { u8"∈", "isinv" },
    { u8"⁢", "it" },
    { u8"Ĩ", "Itilde" },
    { u8"ĩ", "itilde" },
    { u8"І", "Iukcy" },
    { u8"і", "iukcy" },
    { u8"Ï", "Iuml" },
    { u8"ï", "iuml" },
    { u8"Ĵ", "Jcirc" },
    { u8"ĵ", "jcirc" },
    { u8"Й", "Jcy" },
    { u8"й", "jcy" },
    { u8"𝔍", "Jfr" },
    { u8"𝔧", "jfr" },
    { u8"ȷ", "jmath" },
    { u8"𝕁", "Jopf" },
    { u8"𝕛", "jopf" },
    { u8"𝒥", "Jscr" },
    { u8"𝒿", "jscr" },
    { u8"Ј", "Jsercy" },
    { u8"ј", "jsercy" },
    { u8"Є", "Jukcy" },
    { u8"є", "jukcy" },
    { u8"Κ", "Kappa" },
    { u8"κ", "kappa" },
    { u8"ϰ", "kappav" },
    { u8"Ķ", "Kcedil" },
    { u8"ķ", "kcedil" },
    { u8"К", "Kcy" },
    { u8"к", "kcy" },
    { u8"𝔎", "Kfr" },
    { u8"𝔨", "kfr" },
    { u8"ĸ", "kgreen" },
    { u8"Х", "KHcy" },
    { u8"х", "khcy" },
    { u8"Ќ", "KJcy" },
    { u8"ќ", "kjcy" },
    { u8"𝕂", "Kopf" },
    { u8"𝕜", "kopf" },
    { u8"𝒦", "Kscr" },
    { u8"𝓀", "kscr" },
    { u8"⇚", "lAarr" },
    { u8"Ĺ", "Lacute" },
    { u8"ĺ", "lacute" },
    { u8"⦴", "laemptyv" },
    { u8"ℒ", "lagran" },
    { u8"Λ", "Lambda" },
    { u8"λ", "lambda" },
    { u8"⟪", "Lang" },
    { u8"⟨", "lang" },
    { u8"⦑", "langd" },
    { u8"⟨", "langle" },
    { u8"⪅", "lap" },
    { u8"ℒ", "Laplacetrf" },
    { u8"«", "laquo" },
    { u8"↞", "Larr" },
    { u8"⇐", "lArr" },
    { u8"←", "larr" },
    { u8"⇤", "larrb" },
    { u8"⤟", "larrbfs" },
    { u8"⤝", "larrfs" },
    { u8"↩", "larrhk" },
    { u8"↫", "larrlp" },
    { u8"⤹", "larrpl" },
    { u8"⥳", "larrsim" },
    { u8"↢", "larrtl" },
    { u8"⪫", "lat" },
    { u8"⤛", "lAtail" },
    { u8"⤙", "latail" },
    { u8"⪭", "late" },
    { u8"⪭︀", "lates" },
    { u8"⤎", "lBarr" },
    { u8"⤌", "lbarr" },
    { u8"❲", "lbbrk" },
    { u8"{", "lbrace", false },
    { u8"[", "lbrack", false },
    { u8"⦋", "lbrke" },
    { u8"⦏", "lbrksld" },
    { u8"⦍", "lbrkslu" },
    { u8"Ľ", "Lcaron" },
    { u8"ľ", "lcaron" },
    { u8"Ļ", "Lcedil" },
    { u8"ļ", "lcedil" },
    { u8"⌈", "lceil" },
    { u8"{", "lcub", false },
    { u8"Л", "Lcy" },
    { u8"л", "lcy" },
    { u8"⤶", "ldca" },
    { u8"“", "ldquo" },
    { u8"„", "ldquor" },
    { u8"⥧", "ldrdhar" },
    { u8"⥋", "ldrushar" },
    { u8"↲", "ldsh" },
    { u8"≦", "lE" },
    { u8"≤", "le" },
    { u8"⟨", "LeftAngleBracket" },
    { u8"←", "LeftArrow" },
    { u8"⇐", "Leftarrow" },
    { u8"←", "leftarrow" },
    { u8"⇤", "LeftArrowBar" },
    { u8"⇆", "LeftArrowRightArrow" },
    { u8"↢", "leftarrowtail" },
    { u8"⌈", "LeftCeiling" },
    { u8"⟦", "LeftDoubleBracket" },
    { u8"⥡", "LeftDownTeeVector" },
    { u8"⇃", "LeftDownVector" },
    { u8"⥙", "LeftDownVectorBar" },
    { u8"⌊", "LeftFloor" },
    { u8"↽", "leftharpoondown" },
    { u8"↼", "leftharpoonup" },
    { u8"⇇", "leftleftarrows" },
    { u8"↔", "LeftRightArrow" },
    { u8"⇔", "Leftrightarrow" },
    { u8"↔", "leftrightarrow" },
    { u8"⇆", "leftrightarrows" },
    { u8"⇋", "leftrightharpoons" },
    { u8"↭", "leftrightsquigarrow" },
    { u8"⥎", "LeftRightVector" },
    { u8"⊣", "LeftTee" },
    { u8"↤", "LeftTeeArrow" },
    { u8"⥚", "LeftTeeVector" },
    { u8"⋋", "leftthreetimes" },
    { u8"⊲", "LeftTriangle" },
    { u8"⧏", "LeftTriangleBar" },
    { u8"⊴", "LeftTriangleEqual" },
    { u8"⥑", "LeftUpDownVector" },
    { u8"⥠", "LeftUpTeeVector" },
    { u8"↿", "LeftUpVector" },
    { u8"⥘", "LeftUpVectorBar" },
    { u8"↼", "LeftVector" },
    { u8"⥒", "LeftVectorBar" },
    { u8"⪋", "lEg" },
    { u8"⋚", "leg" },
    { u8"≤", "leq" },
    { u8"≦", "leqq" },
    { u8"⩽", "leqslant" },
    { u8"⩽", "les" },
    { u8"⪨", "lescc" },
    { u8"⩿", "lesdot" },
    { u8"⪁", "lesdoto" },
    { u8"⪃", "lesdotor" },
    { u8"⋚︀", "lesg" },
    { u8"⪓", "lesges" },
    { u8"⪅", "lessapprox" },
    { u8"⋖", "lessdot" },
    { u8"⋚", "lesseqgtr" },
    { u8"⪋", "lesseqqgtr" },
    { u8"⋚", "LessEqualGreater" },
    { u8"≦", "LessFullEqual" },
    { u8"≶", "LessGreater" },
    { u8"≶", "lessgtr" },
    { u8"⪡", "LessLess" },
    { u8"≲", "lesssim" },
    { u8"⩽", "LessSlantEqual" },
    { u8"≲", "LessTilde" },
    { u8"⥼", "lfisht" },
    { u8"⌊", "lfloor" },
    { u8"𝔏", "Lfr" },
    { u8"𝔩", "lfr" },
    { u8"≶", "lg" },
    { u8"⪑", "lgE" },
    { u8"⥢", "lHar" },
    { u8"↽", "lhard" },
    { u8"↼", "lharu" },
    { u8"⥪", "lharul" },
    { u8"▄", "lhblk" },
    { u8"Љ", "LJcy" },
    { u8"љ", "ljcy" },
    { u8"⋘", "Ll" },
    { u8"≪", "ll" },
    { u8"⇇", "llarr" },
    { u8"⌞", "llcorner" },
    { u8"⇚", "Lleftarrow" },
    { u8"⥫", "llhard" },
    { u8"◺", "lltri" },
    { u8"Ŀ", "Lmidot" },
    { u8"ŀ", "lmidot" },
    { u8"⎰", "lmoust" },
    { u8"⎰", "lmoustache" },
    { u8"⪉", "lnap" },
    { u8"⪉", "lnapprox" },
    { u8"≨", "lnE" },
    { u8"⪇", "lne" },
    { u8"⪇", "lneq" },
    { u8"≨", "lneqq" },
    { u8"⋦", "lnsim" },
    { u8"⟬", "loang" },
    { u8"⇽", "loarr" },
    { u8"⟦", "lobrk" },
    { u8"⟵", "LongLeftArrow" },
    { u8"⟸", "Longleftarrow" },
    { u8"⟵", "longleftarrow" },
    { u8"⟷", "LongLeftRightArrow" },
    { u8"⟺", "Longleftrightarrow" },
    { u8"⟷", "longleftrightarrow" },
    { u8"⟼", "longmapsto" },
    { u8"⟶", "LongRightArrow" },
    { u8"⟹", "Longrightarrow" },
    { u8"⟶", "longrightarrow" },
    { u8"↫", "looparrowleft" },
    { u8"↬", "looparrowright" },
    { u8"⦅", "lopar" },
    { u8"𝕃", "Lopf" },
    { u8"𝕝", "lopf" },
    { u8"⨭", "loplus" },
    { u8"⨴", "lotimes" },
    { u8"∗", "lowast" },
    { u8"_", "lowbar", false },
    { u8"↙", "LowerLeftArrow" },
    { u8"↘", "LowerRightArrow" },
    { u8"◊", "loz" },
    { u8"◊", "lozenge" },
    { u8"⧫", "lozf" },
    { u8"(", "lpar", false },
    { u8"⦓", "lparlt" },
    { u8"⇆", "lrarr" },
    { u8"⌟", "lrcorner" },
    { u8"⇋", "lrhar" },
    { u8"⥭", "lrhard" },
    { u8"‎", "lrm" },
    { u8"⊿", "lrtri" },
    { u8"‹", "lsaquo" },
    { u8"ℒ", "Lscr" },
    { u8"𝓁", "lscr" },
    { u8"↰", "Lsh" },
    { u8"↰", "lsh" },
    { u8"≲", "lsim" },
    { u8"⪍", "lsime" },
    { u8"⪏", "lsimg" },
    { u8"[", "lsqb", false },
    { u8"‘", "lsquo" },
    { u8"‚", "lsquor" },
    { u8"Ł", "Lstrok" },
    { u8"ł", "lstrok" },
    { u8"<", "lt" },
    { u8"<", "LT" },
    { u8"≪", "Lt" },
    { u8"⪦", "ltcc" },
    { u8"⩹", "ltcir" },
    { u8"⋖", "ltdot" },
    { u8"⋋", "lthree" },
    { u8"⋉", "ltimes" },
    { u8"⥶", "ltlarr" },
    { u8"⩻", "ltquest" },
    { u8"◃", "ltri" },
    { u8"⊴", "ltrie" },
    { u8"◂", "ltrif" },
    { u8"⦖", "ltrPar" },
    { u8"⥊", "lurdshar" },
    { u8"⥦", "luruhar" },
    { u8"≨︀", "lvertneqq" },
    { u8"≨︀", "lvnE" },
    { u8"¯", "macr" },
    { u8"♂", "male" },
    { u8"✠", "malt" },
    { u8"✠", "maltese" },
    { u8"⤅", "Map" },
    { u8"↦", "map" },
    { u8"↦", "mapsto" },
    { u8"↧", "mapstodown" },
    { u8"↤", "mapstoleft" },
    { u8"↥", "mapstoup" },
    { u8"▮", "marker" },
    { u8"⨩", "mcomma" },
    { u8"М", "Mcy" },
    { u8"м", "mcy" },
    { u8"—", "mdash" },
    { u8"∺", "mDDot" },
    { u8"∡", "measuredangle" },
    { u8" ", "MediumSpace" },
    { u8"ℳ", "Mellintrf" },
    { u8"𝔐", "Mfr" },
    { u8"𝔪", "mfr" },
    { u8"℧", "mho" },
    { u8"µ", "micro" },
    { u8"∣", "mid" },
    { u8"*", "midast", false },
    { u8"⫰", "midcir" },
    { u8"·", "middot" },
    { u8"−", "minus" },
    { u8"⊟", "minusb" },
    { u8"∸", "minusd" },
    { u8"⨪", "minusdu" },
    { u8"∓", "MinusPlus" },
    { u8"⫛", "mlcp" },
    { u8"…", "mldr" },
    { u8"∓", "mnplus" },
    { u8"⊧", "models" },
    { u8"𝕄", "Mopf" },
    { u8"𝕞", "mopf" },
    { u8"∓", "mp" },
    { u8"ℳ", "Mscr" },
    { u8"𝓂", "mscr" },
    { u8"∾", "mstpos" },
    { u8"Μ", "Mu" },
    { u8"μ", "mu" },
    { u8"⊸", "multimap" },
    { u8"⊸", "mumap" },
    { u8"∇", "nabla" },
    { u8"Ń", "Nacute" },
    { u8"ń", "nacute" },
    { u8"∠⃒", "nang" },
    { u8"≉", "nap" },
    { u8"⩰̸", "napE" },
    { u8"≋̸", "napid" },
    { u8"ŉ", "napos" },
    { u8"≉", "napprox" },
    { u8"♮", "natur" },
    { u8"♮", "natural" },
    { u8"ℕ", "naturals" },
    { u8" ", "nbsp", false },
    { u8"≎̸", "nbump" },
    { u8"≏̸", "nbumpe" },
    { u8"⩃", "ncap" },
    { u8"Ň", "Ncaron" },
    { u8"ň", "ncaron" },
    { u8"Ņ", "Ncedil" },
    { u8"ņ", "ncedil" },
    { u8"≇", "ncong" },
    { u8"⩭̸", "ncongdot" },
    { u8"⩂", "ncup" },
    { u8"Н", "Ncy" },
    { u8"н", "ncy" },
    { u8"–", "ndash" },
    { u8"≠", "ne" },
    { u8"⤤", "nearhk" },
    { u8"⇗", "neArr" },
    { u8"↗", "nearr" },
    { u8"↗", "nearrow" },
    { u8"≐̸", "nedot" },
    { u8"​", "NegativeMediumSpace" },
    { u8"​", "NegativeThickSpace" },
    { u8"​", "NegativeThinSpace" },
    { u8"​", "NegativeVeryThinSpace" },
    { u8"≢", "nequiv" },
    { u8"⤨", "nesear" },
    { u8"≂̸", "nesim" },
    { u8"≫", "NestedGreaterGreater" },
    { u8"≪", "NestedLessLess" },
    { u8"␊", "NewLine" },
    { u8"∄", "nexist" },
    { u8"∄", "nexists" },
    { u8"𝔑", "Nfr" },
    { u8"𝔫", "nfr" },
    { u8"≧̸", "ngE" },
    { u8"≱", "nge" },
    { u8"≱", "ngeq" },
    { u8"≧̸", "ngeqq" },
    { u8"⩾̸", "ngeqslant" },
    { u8"⩾̸", "nges" },
    { u8"⋙̸", "nGg" },
    { u8"≵", "ngsim" },
    { u8"≫⃒", "nGt" },
    { u8"≯", "ngt" },
    { u8"≯", "ngtr" },
    { u8"≫̸", "nGtv" },
    { u8"⇎", "nhArr" },
    { u8"↮", "nharr" },
    { u8"⫲", "nhpar" },
    { u8"∋", "ni" },
    { u8"⋼", "nis" },
    { u8"⋺", "nisd" },
    { u8"∋", "niv" },
    { u8"Њ", "NJcy" },
    { u8"њ", "njcy" },
    { u8"⇍", "nlArr" },
    { u8"↚", "nlarr" },
    { u8"‥", "nldr" },
    { u8"≦̸", "nlE" },
    { u8"≰", "nle" },
    { u8"⇍", "nLeftarrow" },
    { u8"↚", "nleftarrow" },
    { u8"⇎", "nLeftrightarrow" },
    { u8"↮", "nleftrightarrow" },
    { u8"≰", "nleq" },
    { u8"≦̸", "nleqq" },
    { u8"⩽̸", "nleqslant" },
    { u8"⩽̸", "nles" },
    { u8"≮", "nless" },
    { u8"⋘̸", "nLl" },
    { u8"≴", "nlsim" },
    { u8"≪⃒", "nLt" },
    { u8"≮", "nlt" },
    { u8"⋪", "nltri" },
    { u8"⋬", "nltrie" },
    { u8"≪̸", "nLtv" },
    { u8"∤", "nmid" },
    { u8"⁠", "NoBreak" },
    { u8" ", "NonBreakingSpace", false },
    { u8"ℕ", "Nopf" },
    { u8"𝕟", "nopf" },
    { u8"⫬", "Not" },
    { u8"¬", "not" },
    { u8"≢", "NotCongruent" },
    { u8"≭", "NotCupCap" },
    { u8"∦", "NotDoubleVerticalBar" },
    { u8"∉", "NotElement" },
    { u8"≠", "NotEqual" },
    { u8"≂̸", "NotEqualTilde" },
    { u8"∄", "NotExists" },
    { u8"≯", "NotGreater" },
    { u8"≱", "NotGreaterEqual" },
    { u8"≧̸", "NotGreaterFullEqual" },
    { u8"≫̸", "NotGreaterGreater" },
    { u8"≹", "NotGreaterLess" },
    { u8"⩾̸", "NotGreaterSlantEqual" },
    { u8"≵", "NotGreaterTilde" },
    { u8"≎̸", "NotHumpDownHump" },
    { u8"≏̸", "NotHumpEqual" },
    { u8"∉", "notin" },
    { u8"⋵̸", "notindot" },
    { u8"⋹̸", "notinE" },
    { u8"∉", "notinva" },
    { u8"⋷", "notinvb" },
    { u8"⋶", "notinvc" },
    { u8"⋪", "NotLeftTriangle" },
    { u8"⧏̸", "NotLeftTriangleBar" },
    { u8"⋬", "NotLeftTriangleEqual" },
    { u8"≮", "NotLess" },
    { u8"≰", "NotLessEqual" },
    { u8"≸", "NotLessGreater" },
    { u8"≪̸", "NotLessLess" },
    { u8"⩽̸", "NotLessSlantEqual" },
    { u8"≴", "NotLessTilde" },
    { u8"⪢̸", "NotNestedGreaterGreater" },
    { u8"⪡̸", "NotNestedLessLess" },
    { u8"∌", "notni" },
    { u8"∌", "notniva" },
    { u8"⋾", "notnivb" },
    { u8"⋽", "notnivc" },
    { u8"⊀", "NotPrecedes" },
    { u8"⪯̸", "NotPrecedesEqual" },
    { u8"⋠", "NotPrecedesSlantEqual" },
    { u8"∌", "NotReverseElement" },
    { u8"⋫", "NotRightTriangle" },
    { u8"⧐̸", "NotRightTriangleBar" },
    { u8"⋭", "NotRightTriangleEqual" },
    { u8"⊏̸", "NotSquareSubset" },
    { u8"⋢", "NotSquareSubsetEqual" },
    { u8"⊐̸", "NotSquareSuperset" },
    { u8"⋣", "NotSquareSupersetEqual" },
    { u8"⊂⃒", "NotSubset" },
    { u8"⊈", "NotSubsetEqual" },
    { u8"⊁", "NotSucceeds" },
    { u8"⪰̸", "NotSucceedsEqual" },
    { u8"⋡", "NotSucceedsSlantEqual" },
    { u8"≿̸", "NotSucceedsTilde" },
    { u8"⊃⃒", "NotSuperset" },
    { u8"⊉", "NotSupersetEqual" },
    { u8"≁", "NotTilde" },
    { u8"≄", "NotTildeEqual" },
    { u8"≇", "NotTildeFullEqual" },
    { u8"≉", "NotTildeTilde" },
    { u8"∤", "NotVerticalBar" },
    { u8"∦", "npar" },
    { u8"∦", "nparallel" },
    { u8"⫽⃥", "nparsl" },
    { u8"∂̸", "npart" },
    { u8"⨔", "npolint" },
    { u8"⊀", "npr" },
    { u8"⋠", "nprcue" },
    { u8"⪯̸", "npre" },
    { u8"⊀", "nprec" },
    { u8"⪯̸", "npreceq" },
    { u8"⇏", "nrArr" },
    { u8"↛", "nrarr" },
    { u8"⤳̸", "nrarrc" },
    { u8"↝̸", "nrarrw" },
    { u8"⇏", "nRightarrow" },
    { u8"↛", "nrightarrow" },
    { u8"⋫", "nrtri" },
    { u8"⋭", "nrtrie" },
    { u8"⊁", "nsc" },
    { u8"⋡", "nsccue" },
    { u8"⪰̸", "nsce" },
    { u8"𝒩", "Nscr" },
    { u8"𝓃", "nscr" },
    { u8"∤", "nshortmid" },
    { u8"∦", "nshortparallel" },
    { u8"≁", "nsim" },
    { u8"≄", "nsime" },
    { u8"≄", "nsimeq" },
    { u8"∤", "nsmid" },
    { u8"∦", "nspar" },
    { u8"⋢", "nsqsube" },
    { u8"⋣", "nsqsupe" },
    { u8"⊄", "nsub" },
    { u8"⫅̸", "nsubE" },
    { u8"⊈", "nsube" },
    { u8"⊂⃒", "nsubset" },
    { u8"⊈", "nsubseteq" },
    { u8"⫅̸", "nsubseteqq" },
    { u8"⊁", "nsucc" },
    { u8"⪰̸", "nsucceq" },
    { u8"⊅", "nsup" },
    { u8"⫆̸", "nsupE" },
    { u8"⊉", "nsupe" },
    { u8"⊃⃒", "nsupset" },
    { u8"⊉", "nsupseteq" },
    { u8"⫆̸", "nsupseteqq" },
    { u8"≹", "ntgl" },
    { u8"Ñ", "Ntilde" },
    { u8"ñ", "ntilde" },
    { u8"≸", "ntlg" },
    { u8"⋪", "ntriangleleft" },
    { u8"⋬", "ntrianglelefteq" },
    { u8"⋫", "ntriangleright" },
    { u8"⋭", "ntrianglerighteq" },
    { u8"Ν", "Nu" },
    { u8"ν", "nu" },
    { u8"#", "num", false },
    { u8"№", "numero" },
    { u8" ", "numsp" },
    { u8"≍⃒", "nvap" },
    { u8"⊯", "nVDash" },
    { u8"⊮", "nVdash" },
    { u8"⊭", "nvDash" },
    { u8"⊬", "nvdash" },
    { u8"≥⃒", "nvge" },
    { u8">⃒", "nvgt" },
    { u8"⤄", "nvHarr" },
    { u8"⧞", "nvinfin" },
    { u8"⤂", "nvlArr" },
    { u8"≤⃒", "nvle" },
    { u8"<⃒", "nvlt" },
    { u8"⊴⃒", "nvltrie" },
    { u8"⤃", "nvrArr" },
    { u8"⊵⃒", "nvrtrie" },
    { u8"∼⃒", "nvsim" },
    { u8"⤣", "nwarhk" },
    { u8"⇖", "nwArr" },
    { u8"↖", "nwarr" },
    { u8"↖", "nwarrow" },
    { u8"⤧", "nwnear" },
    { u8"Ó", "Oacute" },
    { u8"ó", "oacute" },
    { u8"⊛", "oast" },
    { u8"⊚", "ocir" },
    { u8"Ô", "Ocirc" },
    { u8"ô", "ocirc" },
    { u8"О", "Ocy" },
    { u8"о", "ocy" },
    { u8"⊝", "odash" },
    { u8"Ő", "Odblac" },
    { u8"ő", "odblac" },
    { u8"⨸", "odiv" },
    { u8"⊙", "odot" },
    { u8"⦼", "odsold" },
    { u8"Œ", "OElig" },
    { u8"œ", "oelig" },
    { u8"⦿", "ofcir" },
    { u8"𝔒", "Ofr" },
    { u8"𝔬", "ofr" },
    { u8"˛", "ogon" },
    { u8"Ò", "Ograve" },
    { u8"ò", "ograve" },
    { u8"⧁", "ogt" },
    { u8"⦵", "ohbar" },
    { u8"Ω", "ohm" },
    { u8"∮", "oint" },
    { u8"↺", "olarr" },
    { u8"⦾", "olcir" },
    { u8"⦻", "olcross" },
    { u8"‾", "oline" },
    { u8"⧀", "olt" },
    { u8"Ō", "Omacr" },
    { u8"ō", "omacr" },
    { u8"Ω", "Omega" },
    { u8"ω", "omega" },
    { u8"Ο", "Omicron" },
    { u8"ο", "omicron" },
    { u8"⦶", "omid" },
    { u8"⊖", "ominus" },
    { u8"𝕆", "Oopf" },
    { u8"𝕠", "oopf" },
    { u8"⦷", "opar" },
    { u8"“", "OpenCurlyDoubleQuote" },
    { u8"‘", "OpenCurlyQuote" },
    { u8"⦹", "operp" },
    { u8"⊕", "oplus" },
    { u8"⩔", "Or" },
    { u8"∨", "or" },
    { u8"↻", "orarr" },
    { u8"⩝", "ord" },
    { u8"ℴ", "order" },
    { u8"ℴ", "orderof" },
    { u8"ª", "ordf" },
    { u8"º", "ordm" },
    { u8"⊶", "origof" },
    { u8"⩖", "oror" },
    { u8"⩗", "orslope" },
    { u8"⩛", "orv" },
    { u8"Ⓢ", "oS" },
    { u8"𝒪", "Oscr" },
    { u8"ℴ", "oscr" },
    { u8"Ø", "Oslash" },
    { u8"ø", "oslash" },
    { u8"⊘", "osol" },
    { u8"Õ", "Otilde" },
    { u8"õ", "otilde" },
    { u8"⨷", "Otimes" },
    { u8"⊗", "otimes" },
    { u8"⨶", "otimesas" },
    { u8"Ö", "Ouml" },
    { u8"ö", "ouml" },
    { u8"⌽", "ovbar" },
    { u8"‾", "OverBar" },
    { u8"⏞", "OverBrace" },
    { u8"⎴", "OverBracket" },
    { u8"⏜", "OverParenthesis" },
    { u8"∥", "par" },
    { u8"¶", "para" },
    { u8"∥", "parallel" },
    { u8"⫳", "parsim" },
    { u8"⫽", "parsl" },
    { u8"∂", "part" },
    { u8"∂", "PartialD" },
    { u8"П", "Pcy" },
    { u8"п", "pcy" },
    { u8"%", "percnt", false },
    { u8".", "period", false },
    { u8"‰", "permil" },
    { u8"⊥", "perp" },
    { u8"‱", "pertenk" },
    { u8"𝔓", "Pfr" },
    { u8"𝔭", "pfr" },
    { u8"Φ", "Phi" },
    { u8"φ", "phi" },
    { u8"ϕ", "phiv" },
    { u8"ℳ", "phmmat" },
    { u8"☎", "phone" },
    { u8"Π", "Pi" },
    { u8"π", "pi" },
    { u8"⋔", "pitchfork" },
    { u8"ϖ", "piv" },
    { u8"ℏ", "planck" },
    { u8"ℎ", "planckh" },
    { u8"ℏ", "plankv" },
    { u8"+", "plus", false },
    { u8"⨣", "plusacir" },
    { u8"⊞", "plusb" },
    { u8"⨢", "pluscir" },
    { u8"∔", "plusdo" },
    { u8"⨥", "plusdu" },
    { u8"⩲", "pluse" },
    { u8"±", "PlusMinus" },
    { u8"±", "plusmn" },
    { u8"⨦", "plussim" },
    { u8"⨧", "plustwo" },
    { u8"±", "pm" },
    { u8"ℌ", "Poincareplane" },
    { u8"⨕", "pointint" },
    { u8"ℙ", "Popf" },
    { u8"𝕡", "popf" },
    { u8"£", "pound" },
    { u8"⪻", "Pr" },
    { u8"≺", "pr" },
    { u8"⪷", "prap" },
    { u8"≼", "prcue" },
    { u8"⪳", "prE" },
    { u8"⪯", "pre" },
    { u8"≺", "prec" },
    { u8"⪷", "precapprox" },
    { u8"≼", "preccurlyeq" },
    { u8"≺", "Precedes" },
    { u8"⪯", "PrecedesEqual" },
    { u8"≼", "PrecedesSlantEqual" },
    { u8"≾", "PrecedesTilde" },
    { u8"⪯", "preceq" },
    { u8"⪹", "precnapprox" },
    { u8"⪵", "precneqq" },
    { u8"⋨", "precnsim" },
    { u8"≾", "precsim" },
    { u8"″", "Prime" },
    { u8"′", "prime" },
    { u8"ℙ", "primes" },
    { u8"⪹", "prnap" },
    { u8"⪵", "prnE" },
    { u8"⋨", "prnsim" },
    { u8"∏", "prod" },
    { u8"∏", "Product" },
    { u8"⌮", "profalar" },
    { u8"⌒", "profline" },
    { u8"⌓", "profsurf" },
    { u8"∝", "prop" },
    { u8"∷", "Proportion" },
    { u8"∝", "Proportional" },
    { u8"∝", "propto" },
    { u8"≾", "prsim" },
    { u8"⊰", "prurel" },
    { u8"𝒫", "Pscr" },
    { u8"𝓅", "pscr" },
    { u8"Ψ", "Psi" },
    { u8"ψ", "psi" },
    { u8" ", "puncsp" },
    { u8"𝔔", "Qfr" },
    { u8"𝔮", "qfr" },
    { u8"⨌", "qint" },
    { u8"ℚ", "Qopf" },
    { u8"𝕢", "qopf" },
    { u8"⁗", "qprime" },
    { u8"𝒬", "Qscr" },
    { u8"𝓆", "qscr" },
    { u8"ℍ", "quaternions" },
    { u8"⨖", "quatint" },
    { u8"?", "quest", false },
    { u8"≟", "questeq" },
    { u8"\"", "QUOT", false },
    { u8"\"", "quot", false },
    { u8"⇛", "rAarr" },
    { u8"∽̱", "race" },
    { u8"Ŕ", "Racute" },
    { u8"ŕ", "racute" },
    { u8"√", "radic" },
    { u8"⦳", "raemptyv" },
    { u8"⟫", "Rang" },
    { u8"⟩", "rang" },
    { u8"⦒", "rangd" },
    { u8"⦥", "range" },
    { u8"⟩", "rangle" },
    { u8"»", "raquo" },
    { u8"↠", "Rarr" },
    { u8"⇒", "rArr" },
    { u8"→", "rarr" },
    { u8"⥵", "rarrap" },
    { u8"⇥", "rarrb" },
    { u8"⤠", "rarrbfs" },
    { u8"⤳", "rarrc" },
    { u8"⤞", "rarrfs" },
    { u8"↪", "rarrhk" },
    { u8"↬", "rarrlp" },
    { u8"⥅", "rarrpl" },
    { u8"⥴", "rarrsim" },
    { u8"⤖", "Rarrtl" },
    { u8"↣", "rarrtl" },
    { u8"↝", "rarrw" },
    { u8"⤜", "rAtail" },
    { u8"⤚", "ratail" },
    { u8"∶", "ratio" },
    { u8"ℚ", "rationals" },
    { u8"⤐", "RBarr" },
    { u8"⤏", "rBarr" },
    { u8"⤍", "rbarr" },
    { u8"❳", "rbbrk" },
    { u8"}", "rbrace", false },
    { u8"]", "rbrack", false },
    { u8"⦌", "rbrke" },
    { u8"⦎", "rbrksld" },
    { u8"⦐", "rbrkslu" },
    { u8"Ř", "Rcaron" },
    { u8"ř", "rcaron" },
    { u8"Ŗ", "Rcedil" },
    { u8"ŗ", "rcedil" },
    { u8"⌉", "rceil" },
    { u8"}", "rcub", false },
    { u8"Р", "Rcy" },
    { u8"р", "rcy" },
    { u8"⤷", "rdca" },
    { u8"⥩", "rdldhar" },
    { u8"”", "rdquo" },
    { u8"”", "rdquor" },
    { u8"↳", "rdsh" },
    { u8"ℜ", "Re" },
    { u8"ℜ", "real" },
    { u8"ℛ", "realine" },
    { u8"ℜ", "realpart" },
    { u8"ℝ", "reals" },
    { u8"▭", "rect" },
    { u8"®", "REG" },
    { u8"®", "reg" },
    { u8"∋", "ReverseElement" },
    { u8"⇋", "ReverseEquilibrium" },
    { u8"⥯", "ReverseUpEquilibrium" },
    { u8"⥽", "rfisht" },
    { u8"⌋", "rfloor" },
    { u8"ℜ", "Rfr" },
    { u8"𝔯", "rfr" },
    { u8"⥤", "rHar" },
    { u8"⇁", "rhard" },
    { u8"⇀", "rharu" },
    { u8"⥬", "rharul" },
    { u8"Ρ", "Rho" },
    { u8"ρ", "rho" },
    { u8"ϱ", "rhov" },
    { u8"⟩", "RightAngleBracket" },
    { u8"→", "RightArrow" },
    { u8"⇒", "Rightarrow" },
    { u8"→", "rightarrow" },
    { u8"⇥", "RightArrowBar" },
    { u8"⇄", "RightArrowLeftArrow" },
    { u8"↣", "rightarrowtail" },
    { u8"⌉", "RightCeiling" },
    { u8"⟧", "RightDoubleBracket" },
    { u8"⥝", "RightDownTeeVector" },
    { u8"⇂", "RightDownVector" },
    { u8"⥕", "RightDownVectorBar" },
    { u8"⌋", "RightFloor" },
    { u8"⇁", "rightharpoondown" },
    { u8"⇀", "rightharpoonup" },
    { u8"⇄", "rightleftarrows" },
    { u8"⇌", "rightleftharpoons" },
    { u8"⇉", "rightrightarrows" },
    { u8"↝", "rightsquigarrow" },
    { u8"⊢", "RightTee" },
    { u8"↦", "RightTeeArrow" },
    { u8"⥛", "RightTeeVector" },
    { u8"⋌", "rightthreetimes" },
    { u8"⊳", "RightTriangle" },
    { u8"⧐", "RightTriangleBar" },
    { u8"⊵", "RightTriangleEqual" },
    { u8"⥏", "RightUpDownVector" },
    { u8"⥜", "RightUpTeeVector" },
    { u8"↾", "RightUpVector" },
    { u8"⥔", "RightUpVectorBar" },
    { u8"⇀", "RightVector" },
    { u8"⥓", "RightVectorBar" },
    { u8"˚", "ring" },
    { u8"≓", "risingdotseq" },
    { u8"⇄", "rlarr" },
    { u8"⇌", "rlhar" },
    { u8"‏", "rlm" },
    { u8"⎱", "rmoust" },
    { u8"⎱", "rmoustache" },
    { u8"⫮", "rnmid" },
    { u8"⟭", "roang" },
    { u8"⇾", "roarr" },
    { u8"⟧", "robrk" },
    { u8"⦆", "ropar" },
    { u8"ℝ", "Ropf" },
    { u8"𝕣", "ropf" },
    { u8"⨮", "roplus" },
    { u8"⨵", "rotimes" },
    { u8"⥰", "RoundImplies" },
    { u8")", "rpar", false },
    { u8"⦔", "rpargt" },
    { u8"⨒", "rppolint" },
    { u8"⇉", "rrarr" },
    { u8"⇛", "Rrightarrow" },
    { u8"›", "rsaquo" },
    { u8"ℛ", "Rscr" },
    { u8"𝓇", "rscr" },
    { u8"↱", "Rsh" },
    { u8"↱", "rsh" },
    { u8"]", "rsqb", false },
    { u8"’", "rsquo" },
    { u8"’", "rsquor" },
    { u8"⋌", "rthree" },
    { u8"⋊", "rtimes" },
    { u8"▹", "rtri" },
    { u8"⊵", "rtrie" },
    { u8"▸", "rtrif" },
    { u8"⧎", "rtriltri" },
    { u8"⧴", "RuleDelayed" },
    { u8"⥨", "ruluhar" },
    { u8"℞", "rx" },
    { u8"Ś", "Sacute" },
    { u8"ś", "sacute" },
    { u8"‚", "sbquo" },
    { u8"⪼", "Sc" },
    { u8"≻", "sc" },
    { u8"⪸", "scap" },
    { u8"Š", "Scaron" },
    { u8"š", "scaron" },
    { u8"≽", "sccue" },
    { u8"⪴", "scE" },
    { u8"⪰", "sce" },
    { u8"Ş", "Scedil" },
    { u8"ş", "scedil" },
    { u8"Ŝ", "Scirc" },
    { u8"ŝ", "scirc" },
    { u8"⪺", "scnap" },
    { u8"⪶", "scnE" },
    { u8"⋩", "scnsim" },
    { u8"⨓", "scpolint" },
    { u8"≿", "scsim" },
    { u8"С", "Scy" },
    { u8"с", "scy" },
    { u8"⋅", "sdot" },
    { u8"⊡", "sdotb" },
    { u8"⩦", "sdote" },
    { u8"⤥", "searhk" },
    { u8"⇘", "seArr" },
    { u8"↘", "searr" },
    { u8"↘", "searrow" },
    { u8"§", "sect" },
    { u8";", "semi", false },
    { u8"⤩", "seswar" },
    { u8"∖", "setminus" },
    { u8"∖", "setmn" },
    { u8"✶", "sext" },
    { u8"𝔖", "Sfr" },
    { u8"𝔰", "sfr" },
    { u8"⌢", "sfrown" },
    { u8"♯", "sharp" },
    { u8"Щ", "SHCHcy" },
    { u8"щ", "shchcy" },
    { u8"Ш", "SHcy" },
    { u8"ш", "shcy" },
    { u8"↓", "ShortDownArrow" },
    { u8"←", "ShortLeftArrow" },
    { u8"∣", "shortmid" },
    { u8"∥", "shortparallel" },
    { u8"→", "ShortRightArrow" },
    { u8"↑", "ShortUpArrow" },
    { u8"­", "shy" },
    { u8"Σ", "Sigma" },
    { u8"σ", "sigma" },
    { u8"ς", "sigmaf" },
    { u8"ς", "sigmav" },
    { u8"∼", "sim" },
    { u8"⩪", "simdot" },
    { u8"≃", "sime" },
    { u8"≃", "simeq" },
    { u8"⪞", "simg" },
    { u8"⪠", "simgE" },
    { u8"⪝", "siml" },
    { u8"⪟", "simlE" },
    { u8"≆", "simne" },
    { u8"⨤", "simplus" },
    { u8"⥲", "simrarr" },
    { u8"←", "slarr" },
    { u8"∘", "SmallCircle" },
    { u8"∖", "smallsetminus" },
    { u8"⨳", "smashp" },
    { u8"⧤", "smeparsl" },
    { u8"∣", "smid" },
    { u8"⌣", "smile" },
    { u8"⪪", "smt" },
    { u8"⪬", "smte" },
    { u8"⪬︀", "smtes" },
    { u8"Ь", "SOFTcy" },
    { u8"ь", "softcy" },
    { u8"/", "sol", false },
    { u8"⧄", "solb" },
    { u8"⌿", "solbar" },
    { u8"𝕊", "Sopf" },
    { u8"𝕤", "sopf" },
    { u8"♠", "spades" },
    { u8"♠", "spadesuit" },
    { u8"∥", "spar" },
    { u8"*", "splat", false },
    { u8"⊓", "sqcap" },
    { u8"⊓︀", "sqcaps" },
    { u8"⊔", "sqcup" },
    { u8"⊔︀", "sqcups" },
    { u8"~", "squiggle", false },
    { u8"√", "Sqrt" },
    { u8"⊏", "sqsub" },
    { u8"⊑", "sqsube" },
    { u8"⊏", "sqsubset" },
    { u8"⊑", "sqsubseteq" },
    { u8"⊐", "sqsup" },
    { u8"⊒", "sqsupe" },
    { u8"⊐", "sqsupset" },
    { u8"⊒", "sqsupseteq" },
    { u8"□", "squ" },
    { u8"□", "Square" },
    { u8"□", "square" },
    { u8"⊓", "SquareIntersection" },
    { u8"⊏", "SquareSubset" },
    { u8"⊑", "SquareSubsetEqual" },
    { u8"⊐", "SquareSuperset" },
    { u8"⊒", "SquareSupersetEqual" },
    { u8"⊔", "SquareUnion" },
    { u8"▪", "squarf" },
    { u8"▪", "squf" },
    { u8"→", "srarr" },
    { u8"𝒮", "Sscr" },
    { u8"𝓈", "sscr" },
    { u8"∖", "ssetmn" },
    { u8"⌣", "ssmile" },
    { u8"⋆", "sstarf" },
    { u8"⋆", "Star" },
    { u8"☆", "star" },
    { u8"★", "starf" },
    { u8"ϵ", "straightepsilon" },
    { u8"ϕ", "straightphi" },
    { u8"¯", "strns" },
    { u8"⋐", "Sub" },
    { u8"⊂", "sub" },
    { u8"⪽", "subdot" },
    { u8"⫅", "subE" },
    { u8"⊆", "sube" },
    { u8"⫃", "subedot" },
    { u8"⫁", "submult" },
    { u8"⫋", "subnE" },
    { u8"⊊", "subne" },
    { u8"⪿", "subplus" },
    { u8"⥹", "subrarr" },
    { u8"⋐", "Subset" },
    { u8"⊂", "subset" },
    { u8"⊆", "subseteq" },
    { u8"⫅", "subseteqq" },
    { u8"⊆", "SubsetEqual" },
    { u8"⊊", "subsetneq" },
    { u8"⫋", "subsetneqq" },
    { u8"⫇", "subsim" },
    { u8"⫕", "subsub" },
    { u8"⫓", "subsup" },
    { u8"≻", "succ" },
    { u8"⪸", "succapprox" },
    { u8"≽", "succcurlyeq" },
    { u8"≻", "Succeeds" },
    { u8"⪰", "SucceedsEqual" },
    { u8"≽", "SucceedsSlantEqual" },
    { u8"≿", "SucceedsTilde" },
    { u8"⪰", "succeq" },
    { u8"⪺", "succnapprox" },
    { u8"⪶", "succneqq" },
    { u8"⋩", "succnsim" },
    { u8"≿", "succsim" },
    { u8"∋", "SuchThat" },
    { u8"∑", "Sum" },
    { u8"∑", "sum" },
    { u8"♪", "sung" },
    { u8"⋑", "Sup" },
    { u8"⊃", "sup" },
    { u8"¹", "sup1" },
    { u8"²", "sup2" },
    { u8"³", "sup3" },
    { u8"⪾", "supdot" },
    { u8"⫘", "supdsub" },
    { u8"⫆", "supE" },
    { u8"⊇", "supe" },
    { u8"⫄", "supedot" },
    { u8"⊃", "Superset" },
    { u8"⊇", "SupersetEqual" },
    { u8"⟉", "suphsol" },
    { u8"⫗", "suphsub" },
    { u8"⥻", "suplarr" },
    { u8"⫂", "supmult" },
    { u8"⫌", "supnE" },
    { u8"⊋", "supne" },
    { u8"⫀", "supplus" },
    { u8"⋑", "Supset" },
    { u8"⊃", "supset" },
    { u8"⊇", "supseteq" },
    { u8"⫆", "supseteqq" },
    { u8"⊋", "supsetneq" },
    { u8"⫌", "supsetneqq" },
    { u8"⫈", "supsim" },
    { u8"⫔", "supsub" },
    { u8"⫖", "supsup" },
    { u8"⤦", "swarhk" },
    { u8"⇙", "swArr" },
    { u8"↙", "swarr" },
    { u8"↙", "swarrow" },
    { u8"⤪", "swnwar" },
    { u8"ß", "szlig" },
    { u8"␉", "Tab" },
    { u8"⌖", "target" },
    { u8"Τ", "Tau" },
    { u8"τ", "tau" },
    { u8"⎴", "tbrk" },
    { u8"Ť", "Tcaron" },
    { u8"ť", "tcaron" },
    { u8"Ţ", "Tcedil" },
    { u8"ţ", "tcedil" },
    { u8"Т", "Tcy" },
    { u8"т", "tcy" },
    { u8"◌⃛", "tdot" },
    { u8"⌕", "telrec" },
    { u8"𝔗", "Tfr" },
    { u8"𝔱", "tfr" },
    { u8"∴", "there4" },
    { u8"∴", "Therefore" },
    { u8"∴", "therefore" },
    { u8"Θ", "Theta" },
    { u8"θ", "theta" },
    { u8"ϑ", "thetasym" },
    { u8"ϑ", "thetav" },
    { u8"≈", "thickapprox" },
    { u8"∼", "thicksim" },
    { u8"  ", "ThickSpace" },
    { u8" ", "thinsp" },
    { u8" ", "ThinSpace" },
    { u8"≈", "thkap" },
    { u8"∼", "thksim" },
    { u8"þ", "thorn" },
    { u8"Þ", "THORN" },
    { u8"∼", "Tilde" },
    { u8"˜", "tilde" },
    { u8"≃", "TildeEqual" },
    { u8"≅", "TildeFullEqual" },
    { u8"≈", "TildeTilde" },
    { u8"×", "times" },
    { u8"⊠", "timesb" },
    { u8"⨱", "timesbar" },
    { u8"⨰", "timesd" },
    { u8"∭", "tint" },
    { u8"⤨", "toea" },
    { u8"⊤", "top" },
    { u8"⌶", "topbot" },
    { u8"⫱", "topcir" },
    { u8"𝕋", "Topf" },
    { u8"𝕥", "topf" },
    { u8"⫚", "topfork" },
    { u8"⤩", "tosa" },
    { u8"‴", "tprime" },
    { u8"™", "trade" },
    { u8"™", "TRADE" },
    { u8"▵", "triangle" },
    { u8"▿", "triangledown" },
    { u8"◃", "triangleleft" },
    { u8"⊴", "trianglelefteq" },
    { u8"≜", "triangleq" },
    { u8"▹", "triangleright" },
    { u8"⊵", "trianglerighteq" },
    { u8"◬", "tridot" },
    { u8"≜", "trie" },
    { u8"⨺", "triminus" },
    { u8"◌⃛", "TripleDot" },
    { u8"⨹", "triplus" },
    { u8"⧍", "trisb" },
    { u8"⨻", "tritime" },
    { u8"⏢", "trpezium" },
    { u8"𝒯", "Tscr" },
    { u8"𝓉", "tscr" },
    { u8"Ц", "TScy" },
    { u8"ц", "tscy" },
    { u8"Ћ", "TSHcy" },
    { u8"ћ", "tshcy" },
    { u8"Ŧ", "Tstrok" },
    { u8"ŧ", "tstrok" },
    { u8"≬", "twixt" },
    { u8"↞", "twoheadleftarrow" },
    { u8"↠", "twoheadrightarrow" },
    { u8"Ú", "Uacute" },
    { u8"ú", "uacute" },
    { u8"↟", "Uarr" },
    { u8"⇑", "uArr" },
    { u8"↑", "uarr" },
    { u8"⥉", "Uarrocir" },
    { u8"Ў", "Ubrcy" },
    { u8"ў", "ubrcy" },
    { u8"Ŭ", "Ubreve" },
    { u8"ŭ", "ubreve" },
    { u8"Û", "Ucirc" },
    { u8"û", "ucirc" },
    { u8"У", "Ucy" },
    { u8"у", "ucy" },
    { u8"⇅", "udarr" },
    { u8"Ű", "Udblac" },
    { u8"ű", "udblac" },
    { u8"⥮", "udhar" },
    { u8"⥾", "ufisht" },
    { u8"𝔘", "Ufr" },
    { u8"𝔲", "ufr" },
    { u8"Ù", "Ugrave" },
    { u8"ù", "ugrave" },
    { u8"⥣", "uHar" },
    { u8"↿", "uharl" },
    { u8"↾", "uharr" },
    { u8"▀", "uhblk" },
    { u8"⌜", "ulcorn" },
    { u8"⌜", "ulcorner" },
    { u8"⌏", "ulcrop" },
    { u8"◸", "ultri" },
    { u8"Ū", "Umacr" },
    { u8"ū", "umacr" },
    { u8"¨", "uml" },
    { u8"_", "UnderBar", false },
    { u8"⏟", "UnderBrace" },
    { u8"⎵", "UnderBracket" },
    { u8"⏝", "UnderParenthesis" },
    { u8"⋃", "Union" },
    { u8"⊎", "UnionPlus" },
    { u8"Ų", "Uogon" },
    { u8"ų", "uogon" },
    { u8"𝕌", "Uopf" },
    { u8"𝕦", "uopf" },
    { u8"↑", "UpArrow" },
    { u8"⇑", "Uparrow" },
    { u8"↑", "uparrow" },
    { u8"⤒", "UpArrowBar" },
    { u8"⇅", "UpArrowDownArrow" },
    { u8"↕", "UpDownArrow" },
    { u8"⇕", "Updownarrow" },
    { u8"↕", "updownarrow" },
    { u8"⥮", "UpEquilibrium" },
    { u8"↿", "upharpoonleft" },
    { u8"↾", "upharpoonright" },
    { u8"⊎", "uplus" },
    { u8"↖", "UpperLeftArrow" },
    { u8"↗", "UpperRightArrow" },
    { u8"ϒ", "Upsi" },
    { u8"υ", "upsi" },
    { u8"ϒ", "upsih" },
    { u8"Υ", "Upsilon" },
    { u8"υ", "upsilon" },
    { u8"⊥", "UpTee" },
    { u8"↥", "UpTeeArrow" },
    { u8"⇈", "upuparrows" },
    { u8"⌝", "urcorn" },
    { u8"⌝", "urcorner" },
    { u8"⌎", "urcrop" },
    { u8"Ů", "Uring" },
    { u8"ů", "uring" },
    { u8"◹", "urtri" },
    { u8"𝒰", "Uscr" },
    { u8"𝓊", "uscr" },
    { u8"⋰", "utdot" },
    { u8"Ũ", "Utilde" },
    { u8"ũ", "utilde" },
    { u8"▵", "utri" },
    { u8"▴", "utrif" },
    { u8"⇈", "uuarr" },
    { u8"Ü", "Uuml" },
    { u8"ü", "uuml" },
    { u8"⦧", "uwangle" },
    { u8"⦜", "vangrt" },
    { u8"ϵ", "varepsilon" },
    { u8"ϰ", "varkappa" },
    { u8"∅", "varnothing" },
    { u8"ϕ", "varphi" },
    { u8"ϖ", "varpi" },
    { u8"∝", "varpropto" },
    { u8"⇕", "vArr" },
    { u8"↕", "varr" },
    { u8"ϱ", "varrho" },
    { u8"ς", "varsigma" },
    { u8"⊊︀", "varsubsetneq" },
    { u8"⫋︀", "varsubsetneqq" },
    { u8"⊋︀", "varsupsetneq" },
    { u8"⫌︀", "varsupsetneqq" },
    { u8"ϑ", "vartheta" },
    { u8"⊲", "vartriangleleft" },
    { u8"⊳", "vartriangleright" },
    { u8"⫫", "Vbar" },
    { u8"⫨", "vBar" },
    { u8"⫩", "vBarv" },
    { u8"В", "Vcy" },
    { u8"в", "vcy" },
    { u8"⊫", "VDash" },
    { u8"⊩", "Vdash" },
    { u8"⊨", "vDash" },
    { u8"⊢", "vdash" },
    { u8"⫦", "Vdashl" },
    { u8"⋁", "Vee" },
    { u8"∨", "vee" },
    { u8"⊻", "veebar" },
    { u8"≚", "veeeq" },
    { u8"⋮", "vellip" },
    { u8"‖", "Verbar" },
    { u8"|", "verbar", false },
    { u8"‖", "Vert" },
    { u8"|", "vert", false },
    { u8"∣", "VerticalBar" },
    { u8"|", "VerticalLine", false },
    { u8"❘", "VerticalSeparator" },
    { u8"≀", "VerticalTilde" },
    { u8" ", "VeryThinSpace" },
    { u8"𝔙", "Vfr" },
    { u8"𝔳", "vfr" },
    { u8"⊲", "vltri" },
    { u8"⊂⃒", "vnsub" },
    { u8"⊃⃒", "vnsup" },
    { u8"𝕍", "Vopf" },
    { u8"𝕧", "vopf" },
    { u8"∝", "vprop" },
    { u8"⊳", "vrtri" },
    { u8"𝒱", "Vscr" },
    { u8"𝓋", "vscr" },
    { u8"⫋︀", "vsubnE" },
    { u8"⊊︀", "vsubne" },
    { u8"⫌︀", "vsupnE" },
    { u8"⊋︀", "vsupne" },
    { u8"⊪", "Vvdash" },
    { u8"⦚", "vzigzag" },
    { u8"Ŵ", "Wcirc" },
    { u8"ŵ", "wcirc" },
    { u8"⩟", "wedbar" },
    { u8"⋀", "Wedge" },
    { u8"∧", "wedge" },
    { u8"≙", "wedgeq" },
    { u8"℘", "weierp" },
    { u8"𝔚", "Wfr" },
    { u8"𝔴", "wfr" },
    { u8"𝕎", "Wopf" },
    { u8"𝕨", "wopf" },
    { u8"℘", "wp" },
    { u8"≀", "wr" },
    { u8"≀", "wreath" },
    { u8"𝒲", "Wscr" },
    { u8"𝓌", "wscr" },
    { u8"⋂", "xcap" },
    { u8"◯", "xcirc" },
    { u8"⋃", "xcup" },
    { u8"▽", "xdtri" },
    { u8"𝔛", "Xfr" },
    { u8"𝔵", "xfr" },
    { u8"⟺", "xhArr" },
    { u8"⟷", "xharr" },
    { u8"Ξ", "Xi" },
    { u8"ξ", "xi" },
    { u8"⟸", "xlArr" },
    { u8"⟵", "xlarr" },
    { u8"⟼", "xmap" },
    { u8"⋻", "xnis" },
    { u8"⨀", "xodot" },
    { u8"𝕏", "Xopf" },
    { u8"𝕩", "xopf" },
    { u8"⨁", "xoplus" },
    { u8"⨂", "xotime" },
    { u8"⟹", "xrArr" },
    { u8"⟶", "xrarr" },
    { u8"𝒳", "Xscr" },
    { u8"𝓍", "xscr" },
    { u8"⨆", "xsqcup" },
    { u8"⨄", "xuplus" },
    { u8"△", "xutri" },
    { u8"⋁", "xvee" },
    { u8"⋀", "xwedge" },
    { u8"Ý", "Yacute" },
    { u8"ý", "yacute" },
    { u8"Я", "YAcy" },
    { u8"я", "yacy" },
    { u8"Ŷ", "Ycirc" },
    { u8"ŷ", "ycirc" },
    { u8"Ы", "Ycy" },
    { u8"ы", "ycy" },
    { u8"¥", "yen" },
    { u8"𝔜", "Yfr" },
    { u8"𝔶", "yfr" },
    { u8"Ї", "YIcy" },
    { u8"ї", "yicy" },
    { u8"𝕐", "Yopf" },
    { u8"𝕪", "yopf" },
    { u8"𝒴", "Yscr" },
    { u8"𝓎", "yscr" },
    { u8"Ю", "YUcy" },
    { u8"ю", "yucy" },
    { u8"Ÿ", "Yuml" },
    { u8"ÿ", "yuml" },
    { u8"Ź", "Zacute" },
    { u8"ź", "zacute" },
    { u8"Ž", "Zcaron" },
    { u8"ž", "zcaron" },
    { u8"З", "Zcy" },
    { u8"з", "zcy" },
    { u8"Ż", "Zdot" },
    { u8"ż", "zdot" },
    { u8"ℨ", "zeetrf" },
    { u8"​", "ZeroWidthSpace" },
    { u8"Ζ", "Zeta" },
    { u8"ζ", "zeta" },
    { u8"ℨ", "Zfr" },
    { u8"𝔷", "zfr" },
    { u8"Ж", "ZHcy" },
    { u8"ж", "zhcy" },
    { u8"⇝", "zigrarr" },
    { u8"ℤ", "Zopf" },
    { u8"𝕫", "zopf" },
    { u8"𝒵", "Zscr" },
    { u8"𝓏", "zscr" },
    { u8"‍", "zwj" },
    { u8"‌", "zwnj" },
    { nullptr, nullptr } };

// WARNING: some symbols may display incorrectly in some editors on some systems: edit them at your peril.
extra_t xtra [] =
{   { u8"™", "TM" },
    { u8"…", "..." },
    { u8"©", "(c)" },
    { u8"©", "(C)" },
    { u8"—", "---" },
    { u8"⅛", "1/8" },
    { u8"⅙", "1/6" },
    { u8"⅕", "1/5" },
    { u8"¼", "1/4" },
    { u8"⅓", "1/3" },
    { u8"⅖", "2/5" },
    { u8"⅜", "3/8" },
    { u8"½", "1/2" },
    { u8"⅗", "3/5" },
    { u8"⅝", "5/8" },
    { u8"⅔", "2/3" },
    { u8"¾", "3/4" },
    { u8"⅘", "4/5" },
    { u8"⅚", "5/6" },
    { u8"⅞", "7/8" },
    { u8"Æ", "AE" },
    { u8"Ǳ", "DZ" },
    { u8"ǲ", "Dz" },
    { u8"Ĳ", "IJ" },
    { u8"Ǉ", "LJ" },
    { u8"ǈ", "Lj" },
    { u8"Ǌ", "NJ" },
    { u8"ǋ", "Nj" },
    { u8"Œ", "OE" },
    { u8"æ", "ae" },
    { u8"ǳ", "dz" },
    { u8"ﬃ", "ffi" },
    { u8"ﬀ", "ff" },
    { u8"ﬄ", "ffl" },
    { u8"ﬁ", "fi" },
    { u8"fj", "fj" },
    { u8"ﬂ", "fl" },
    { u8"ĳ", "ij" },
    { u8"ǉ", "lj" },
    { u8"ǌ", "nj" },
    { u8"œ", "oe" },
    { u8"ﬂ", "fll" },
    { nullptr, nullptr } };
